]> git.ipfire.org Git - thirdparty/dracut.git/blame - dracut.sh
dracut_mkdir(): create parent directories as needed.
[thirdparty/dracut.git] / dracut.sh
CommitLineData
c1c78f8a 1#!/bin/bash -p
3b403b32 2#
641cc356
JK
3# Generator script for a dracut initramfs
4# Tries to retain some degree of compatibility with the command line
5# of the various mkinitrd implementations out there
6#
70c26b7f 7
7d848c55 8# Copyright 2005-2013 Red Hat, Inc. All rights reserved.
4f18fe82
HH
9#
10# This program is free software; you can redistribute it and/or modify
11# it under the terms of the GNU General Public License as published by
12# the Free Software Foundation; either version 2 of the License, or
13# (at your option) any later version.
14#
15# This program is distributed in the hope that it will be useful,
16# but WITHOUT ANY WARRANTY; without even the implied warranty of
17# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
18# GNU General Public License for more details.
19#
20# You should have received a copy of the GNU General Public License
21# along with this program. If not, see <http://www.gnu.org/licenses/>.
22#
ec9315e5 23
58dad702 24# store for logging
ee44f629 25
c1c78f8a
RM
26unset BASH_ENV
27
ee44f629
HH
28# Verify bash version, current minimum is 4
29if (( BASH_VERSINFO[0] < 4 )); then
30 printf -- 'You need at least Bash 4 to use dracut, sorry.' >&2
31 exit 1
32fi
33
ffa71b4a 34dracut_args=( "$@" )
e8f19bcf 35readonly dracut_cmd="$(readlink -f $0)"
5616feb0 36
7abd4264
HH
37set -o pipefail
38
5616feb0 39usage() {
0595a79b 40 [[ $sysroot_l ]] && dracutsysrootdir="$sysroot_l"
a0120420 41 [[ $dracutbasedir ]] || dracutbasedir=$dracutsysrootdir/usr/lib/dracut
dbf8f6ba
HH
42 if [[ -f $dracutbasedir/dracut-version.sh ]]; then
43 . $dracutbasedir/dracut-version.sh
44 fi
45
5616feb0 46# 80x25 linebreak here ^
cc02093d 47 cat << EOF
e8f19bcf 48Usage: $dracut_cmd [OPTION]... [<initramfs> [<kernel-version>]]
ffa71b4a
HH
49
50Version: $DRACUT_VERSION
51
52Creates initial ramdisk images for preloading modules
53
54 -h, --help Display all options
55
56If a [LIST] has multiple arguments, then you have to put these in quotes.
57
58For example:
59
60 # dracut --add-drivers "module1 module2" ...
61
62EOF
63}
64
65long_usage() {
a0120420 66 [[ $dracutbasedir ]] || dracutbasedir=$dracutsysrootdir/usr/lib/dracut
ffa71b4a
HH
67 if [[ -f $dracutbasedir/dracut-version.sh ]]; then
68 . $dracutbasedir/dracut-version.sh
69 fi
70
71# 80x25 linebreak here ^
72 cat << EOF
e8f19bcf 73Usage: $dracut_cmd [OPTION]... [<initramfs> [<kernel-version>]]
dbf8f6ba
HH
74
75Version: $DRACUT_VERSION
76
5616feb0
AT
77Creates initial ramdisk images for preloading modules
78
e65caf36 79 --kver [VERSION] Set kernel version to [VERSION].
39ff0682 80 -f, --force Overwrite existing initramfs file.
54e7d7c3 81 -a, --add [LIST] Add a space-separated list of dracut modules.
659dc319 82 --rebuild Append arguments to those of existing image and rebuild
5616feb0
AT
83 -m, --modules [LIST] Specify a space-separated list of dracut modules to
84 call when building the initramfs. Modules are located
c5a65990 85 in /usr/lib/dracut/modules.d.
39ff0682 86 -o, --omit [LIST] Omit a space-separated list of dracut modules.
ea3c4e82
HH
87 --force-add [LIST] Force to add a space-separated list of dracut modules
88 to the default set of modules, when -H is specified.
5616feb0 89 -d, --drivers [LIST] Specify a space-separated list of kernel modules to
ea3c4e82
HH
90 exclusively include in the initramfs.
91 --add-drivers [LIST] Specify a space-separated list of kernel
92 modules to add to the initramfs.
cea907f6
TR
93 --force-drivers [LIST] Specify a space-separated list of kernel
94 modules to add to the initramfs and make sure they
95 are tried to be loaded via modprobe same as passing
96 rd.driver.pre=DRIVER kernel parameter.
fcbcb252 97 --omit-drivers [LIST] Specify a space-separated list of kernel
ea3c4e82 98 modules not to add to the initramfs.
8fa510d4 99 --filesystems [LIST] Specify a space-separated list of kernel filesystem
ea3c4e82
HH
100 modules to exclusively include in the generic
101 initramfs.
3b403b32 102 -k, --kmoddir [DIR] Specify the directory, where to look for kernel
ea3c4e82 103 modules
3b403b32 104 --fwdir [DIR] Specify additional directories, where to look for
ea3c4e82 105 firmwares, separated by :
33ee031c
HH
106 --kernel-only Only install kernel drivers and firmware files
107 --no-kernel Do not install kernel drivers and firmware files
1743473b 108 --print-cmdline Print the kernel command line for the given disk layout
5bbfd484 109 --early-microcode Combine early microcode with ramdisk
5f2c30d9 110 --no-early-microcode Do not combine early microcode with ramdisk
d20fb951 111 --kernel-cmdline [PARAMETERS] Specify default kernel command line parameters
54e7d7c3 112 --strip Strip binaries in the initramfs
6c128565 113 --nostrip Do not strip binaries in the initramfs
54e7d7c3 114 --hardlink Hardlink files in the initramfs
04d18f55 115 --nohardlink Do not hardlink files in the initramfs
fd786adc 116 --prefix [DIR] Prefix initramfs files with [DIR]
54e7d7c3 117 --noprefix Do not prefix initramfs files
2f02ae9d
HH
118 --mdadmconf Include local /etc/mdadm.conf
119 --nomdadmconf Do not include local /etc/mdadm.conf
7a34efa5 120 --lvmconf Include local /etc/lvm/lvm.conf
cc02093d 121 --nolvmconf Do not include local /etc/lvm/lvm.conf
25b45979
MS
122 --fscks [LIST] Add a space-separated list of fsck helpers.
123 --nofscks Inhibit installation of any fsck helpers.
ff3953ef 124 --ro-mnt Mount / and /usr read-only by default.
5616feb0 125 -h, --help This message
00531568 126 --debug Output debug information of the build process
57258a2c 127 --profile Output profile information of the build process
e103615b
128 -L, --stdlog [0-6] Specify logging level (to standard error)
129 0 - suppress any messages
130 1 - only fatal errors
131 2 - all errors
132 3 - warnings
54e7d7c3 133 4 - info
e103615b
134 5 - debug info (here starts lots of output)
135 6 - trace info (and even more)
54e7d7c3
HH
136 -v, --verbose Increase verbosity level
137 -q, --quiet Decrease verbosity level
5616feb0
AT
138 -c, --conf [FILE] Specify configuration file to use.
139 Default: /etc/dracut.conf
3b403b32 140 --confdir [DIR] Specify configuration directory to use *.conf files
cc02093d 141 from. Default: /etc/dracut.conf.d
882c4c5a
142 --tmpdir [DIR] Temporary directory to be used instead of default
143 /var/tmp.
a0120420 144 -r, --sysroot [DIR] Specify sysroot directory to collect files from.
5616feb0
AT
145 -l, --local Local mode. Use modules from the current working
146 directory instead of the system-wide installed in
c5a65990 147 /usr/lib/dracut/modules.d.
5616feb0 148 Useful when running dracut from a git checkout.
7c179686 149 -H, --hostonly Host-Only mode: Install only what is needed for
324ea606 150 booting the local host instead of a generic host.
472189da 151 -N, --no-hostonly Disables Host-Only mode
a695250e
KS
152 --hostonly-mode <mode>
153 Specify the hostonly mode to use. <mode> could be
154 one of "sloppy" or "strict". "sloppy" mode is used
155 by default.
156 In "sloppy" hostonly mode, extra drivers and modules
157 will be installed, so minor hardware change won't make
158 the image unbootable (eg. changed keyboard), and the
159 image is still portable among similar hosts.
160 With "strict" mode enabled, anything not necessary
161 for booting the local host in its current state will
162 not be included, and modules may do some extra job
163 to save more space. Minor change of hardware or
164 environment could make the image unbootable.
165 DO NOT use "strict" mode unless you know what you
166 are doing.
ab9457ef
HH
167 --hostonly-cmdline Store kernel command line arguments needed
168 in the initramfs
169 --no-hostonly-cmdline Do not store kernel command line arguments needed
170 in the initramfs
37f2fe55
XP
171 --no-hostonly-default-device
172 Do not generate implicit host devices like root,
173 swap, fstab, etc. Use "--mount" or "--add-device"
174 to explicitly add devices as needed.
f367b738
HH
175 --hostonly-i18n Install only needed keyboard and font files according
176 to the host configuration (default).
177 --no-hostonly-i18n Install all keyboard and font files available.
324ea606
HH
178 --persistent-policy [POLICY]
179 Use [POLICY] to address disks and partitions.
180 POLICY can be any directory name found in /dev/disk.
181 E.g. "by-uuid", "by-label"
7c179686 182 --fstab Use /etc/fstab to determine the root device.
70cb8a68
HH
183 --add-fstab [FILE] Add file to the initramfs fstab
184 --mount "[DEV] [MP] [FSTYPE] [FSOPTS]"
185 Mount device [DEV] on mountpoint [MP] with filesystem
186 [FSTYPE] and options [FSOPTS] in the initramfs
edbd9ca0
FV
187 --mount "[MP]" Same as above, but [DEV], [FSTYPE] and [FSOPTS] are
188 determined by looking at the current mounts.
c586b033 189 --add-device "[DEV]" Bring up [DEV] in initramfs
5616feb0 190 -i, --include [SOURCE] [TARGET]
39ff0682
AT
191 Include the files in the SOURCE directory into the
192 Target directory in the final initramfs.
3b403b32 193 If SOURCE is a file, it will be installed to TARGET
4fea3ea6 194 in the final initramfs.
39ff0682
AT
195 -I, --install [LIST] Install the space separated list of files into the
196 initramfs.
54b68829
HH
197 --install-optional [LIST] Install the space separated list of files into the
198 initramfs, if they exist.
5b158ad3 199 --gzip Compress the generated initramfs using gzip.
cc02093d
HH
200 This will be done by default, unless another
201 compression option or --no-compress is passed.
5b158ad3 202 --bzip2 Compress the generated initramfs using bzip2.
cc02093d
HH
203 Make sure your kernel has bzip2 decompression support
204 compiled in, otherwise you will not be able to boot.
205 --lzma Compress the generated initramfs using lzma.
3b403b32 206 Make sure your kernel has lzma support compiled in,
cc02093d 207 otherwise you will not be able to boot.
5e6c3b03
VL
208 --xz Compress the generated initramfs using xz.
209 Make sure that your kernel has xz support compiled
210 in, otherwise you will not be able to boot.
37383f71 211 --lzo Compress the generated initramfs using lzop.
871c8e40 212 Make sure that your kernel has lzo support compiled
213 in, otherwise you will not be able to boot.
37383f71 214 --lz4 Compress the generated initramfs using lz4.
871c8e40 215 Make sure that your kernel has lz4 support compiled
216 in, otherwise you will not be able to boot.
7dbadcc7
TPG
217 --zstd Compress the generated initramfs using Zstandard.
218 Make sure that your kernel has zstd support compiled
219 in, otherwise you will not be able to boot.
5e6c3b03
VL
220 --compress [COMPRESSION] Compress the generated initramfs with the
221 passed compression program. Make sure your kernel
3b403b32 222 knows how to decompress the generated initramfs,
5e6c3b03 223 otherwise you will not be able to boot.
5b158ad3 224 --no-compress Do not compress the generated initramfs. This will
cc02093d 225 override any other compression options.
5b11bb73 226 --list-modules List all available dracut modules.
956af8f2
227 -M, --show-modules Print included module's name to standard output during
228 build.
5fe5c7d0 229 --keep Keep the temporary initramfs for debugging purposes
ec3c5951 230 --printsize Print out the module install size
cdfeb278 231 --sshkey [SSHKEY] Add ssh key to initramfs (use with ssh-client module)
ee54b840 232 --logfile [FILE] Logfile to use (overrides configuration setting)
80626ded 233 --reproducible Create reproducible images
10f8df1b 234 --no-reproducible Do not create reproducible images
37383f71 235 --loginstall [DIR] Log all files installed from the host to [DIR]
636d2d46
HH
236 --uefi Create an UEFI executable with the kernel cmdline and
237 kernel combined
238 --uefi-stub [FILE] Use the UEFI stub [FILE] to create an UEFI executable
4237aeb0
DT
239 --uefi-splash-image [FILE]
240 Use [FILE] as a splash image when creating an UEFI
241 executable
636d2d46 242 --kernel-image [FILE] location of the kernel image
ccaa9bee
HH
243
244If [LIST] has multiple arguments, then you have to put these in quotes.
ffa71b4a 245
ccaa9bee 246For example:
ffa71b4a
HH
247
248 # dracut --add-drivers "module1 module2" ...
249
cc02093d 250EOF
5616feb0
AT
251}
252
118ca9ec
TR
253# Fills up host_devs stack variable and makes sure there are no duplicates
254push_host_devs() {
255 local _dev
694725ab
HH
256 for _dev in "$@"; do
257 [[ " ${host_devs[@]} " == *" $_dev "* ]] && return
258 host_devs+=( "$_dev" )
259 done
8466db96
HH
260}
261
5bc545ed
VL
262# Little helper function for reading args from the commandline.
263# it automatically handles -a b and -a=b variants, and returns 1 if
264# we need to shift $3.
265read_arg() {
266 # $1 = arg name
267 # $2 = arg value
268 # $3 = arg parameter
269 local rematch='^[^=]*=(.*)$'
270 if [[ $2 =~ $rematch ]]; then
cc02093d 271 read "$1" <<< "${BASH_REMATCH[1]}"
5bc545ed 272 else
cc02093d
HH
273 read "$1" <<< "$3"
274 # There is no way to shift our callers args, so
275 # return 1 to indicate they should do it instead.
276 return 1
5bc545ed
VL
277 fi
278}
279
335bc217 280dropindirs_sort()
a42b2b81 281{
b093aa2d
HH
282 local suffix=$1; shift
283 local -a files
284 local f d
285
dba20559
HH
286 for d in "$@"; do
287 for i in "$d/"*"$suffix"; do
288 if [[ -e "$i" ]]; then
289 printf "%s\n" "${i##*/}"
290 fi
291 done
292 done | sort -Vu | {
293 readarray -t files
294
295 for f in "${files[@]}"; do
296 for d in "$@"; do
297 if [[ -e "$d/$f" ]]; then
298 printf "%s\n" "$d/$f"
299 continue 2
b093aa2d 300 fi
a42b2b81 301 done
a42b2b81 302 done
dba20559 303 }
a42b2b81
HH
304}
305
659dc319
HB
306rearrange_params()
307{
308 # Workaround -i, --include taking 2 arguments
dcacd2b0
FV
309 newat=()
310 for i in "$@"; do
311 if [[ $i == "-i" ]] || [[ $i == "--include" ]]; then
312 newat+=("++include") # Replace --include by ++include
313 else
314 newat+=("$i")
315 fi
316 done
317 set -- "${newat[@]}" # Set new $@
659dc319
HB
318
319 TEMP=$(unset POSIXLY_CORRECT; getopt \
b552d364 320 -o "a:m:o:d:I:k:c:r:L:fvqlHhMN" \
659dc319
HB
321 --long kver: \
322 --long add: \
323 --long force-add: \
324 --long add-drivers: \
cea907f6 325 --long force-drivers: \
659dc319
HB
326 --long omit-drivers: \
327 --long modules: \
328 --long omit: \
329 --long drivers: \
330 --long filesystems: \
331 --long install: \
54b68829 332 --long install-optional: \
659dc319
HB
333 --long fwdir: \
334 --long libdirs: \
335 --long fscks: \
336 --long add-fstab: \
337 --long mount: \
338 --long device: \
339 --long add-device: \
ae989390 340 --long nofscks \
659dc319
HB
341 --long ro-mnt \
342 --long kmoddir: \
343 --long conf: \
344 --long confdir: \
345 --long tmpdir: \
b552d364 346 --long sysroot: \
659dc319
HB
347 --long stdlog: \
348 --long compress: \
349 --long prefix: \
350 --long rebuild: \
351 --long force \
352 --long kernel-only \
353 --long no-kernel \
354 --long print-cmdline \
355 --long kernel-cmdline: \
356 --long strip \
357 --long nostrip \
659dc319
HB
358 --long hardlink \
359 --long nohardlink \
360 --long noprefix \
361 --long mdadmconf \
362 --long nomdadmconf \
363 --long lvmconf \
364 --long nolvmconf \
365 --long debug \
366 --long profile \
367 --long sshkey: \
368 --long logfile: \
369 --long verbose \
370 --long quiet \
371 --long local \
372 --long hostonly \
373 --long host-only \
374 --long no-hostonly \
375 --long no-host-only \
a695250e 376 --long hostonly-mode: \
646e0506
WC
377 --long hostonly-cmdline \
378 --long no-hostonly-cmdline \
37f2fe55 379 --long no-hostonly-default-device \
659dc319
HB
380 --long persistent-policy: \
381 --long fstab \
382 --long help \
383 --long bzip2 \
384 --long lzma \
385 --long xz \
386 --long lzo \
387 --long lz4 \
7dbadcc7 388 --long zstd \
659dc319
HB
389 --long no-compress \
390 --long gzip \
391 --long list-modules \
392 --long show-modules \
393 --long keep \
394 --long printsize \
395 --long regenerate-all \
396 --long noimageifnotneeded \
397 --long early-microcode \
398 --long no-early-microcode \
80626ded 399 --long reproducible \
10f8df1b 400 --long no-reproducible \
37383f71 401 --long loginstall: \
636d2d46
HH
402 --long uefi \
403 --long uefi-stub: \
4237aeb0 404 --long uefi-splash-image: \
636d2d46 405 --long kernel-image: \
b73e00af
HH
406 --long no-hostonly-i18n \
407 --long hostonly-i18n \
5c57209b 408 --long no-machineid \
659dc319
HB
409 -- "$@")
410
411 if (( $? != 0 )); then
412 usage
413 exit 1
414 fi
415}
416
432196ae 417verbosity_mod_l=0
f79e587c
HH
418unset kernel
419unset outfile
486a1b93 420
659dc319
HB
421rearrange_params "$@"
422eval set -- "$TEMP"
423
424# parse command line args to check if '--rebuild' option is present
425unset append_args_l
426unset rebuild_file
427while :
428do
429 if [ "$1" == "--" ]; then
430 shift; break
431 fi
432 if [ "$1" == "--rebuild" ]; then
433 append_args_l="yes"
434 rebuild_file=$2
435 if [ ! -e $rebuild_file ]; then
436 echo "Image file '$rebuild_file', for rebuild, does not exist!"
437 exit 1
438 fi
439 abs_rebuild_file=$(readlink -f "$rebuild_file") && rebuild_file="$abs_rebuild_file"
440 shift; continue
441 fi
442 shift
443done
444
445# get output file name and kernel version from command line arguments
446while (($# > 0)); do
447 case ${1%%=*} in
448 ++include)
449 shift 2;;
450 *)
451 if ! [[ ${outfile+x} ]]; then
452 outfile=$1
453 elif ! [[ ${kernel+x} ]]; then
454 kernel=$1
455 else
456 printf "\nUnknown arguments: %s\n\n" "$*" >&2
457 usage; exit 1;
458 fi
459 ;;
460 esac
461 shift
462done
463
464# extract input image file provided with rebuild option to get previous parameters, if any
465if [[ $append_args_l == "yes" ]]; then
466 unset rebuild_param
467
468 # determine resultant file
469 if ! [[ $outfile ]]; then
470 outfile=$rebuild_file
471 fi
472
473 if ! rebuild_param=$(lsinitrd $rebuild_file '*lib/dracut/build-parameter.txt'); then
474 echo "Image '$rebuild_file' has no rebuild information stored"
475 exit 1
476 fi
477
478 # prepend previous parameters to current command line args
479 if [[ $rebuild_param ]]; then
480 TEMP="$rebuild_param $TEMP"
481 eval set -- "$TEMP"
482 rearrange_params "$@"
483 fi
ffa71b4a
HH
484fi
485
659dc319
HB
486unset PARMS_TO_STORE
487PARMS_TO_STORE=""
488
ffa71b4a
HH
489eval set -- "$TEMP"
490
491while :; do
659dc319
HB
492 if [ $1 != "--" ] && [ $1 != "--rebuild" ]; then
493 PARMS_TO_STORE+=" $1";
494 fi
ffa71b4a 495 case $1 in
5a66d511
HH
496 --kver) kernel="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
497 -a|--add) add_dracutmodules_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
498 --force-add) force_add_dracutmodules_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
499 --add-drivers) add_drivers_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
500 --force-drivers) force_drivers_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
501 --omit-drivers) omit_drivers_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
502 -m|--modules) dracutmodules_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
503 -o|--omit) omit_dracutmodules_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
504 -d|--drivers) drivers_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
505 --filesystems) filesystems_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
506 -I|--install) install_items_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
507 --install-optional) install_optional_items_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
508 --fwdir) fw_dir_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
509 --libdirs) libdirs_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
510 --fscks) fscks_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
511 --add-fstab) add_fstab_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
512 --mount) fstab_lines+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
513 --add-device|--device) add_device_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
514 --kernel-cmdline) kernel_cmdline_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
25b45979 515 --nofscks) nofscks_l="yes";;
ff3953ef 516 --ro-mnt) ro_mnt_l="yes";;
659dc319
HB
517 -k|--kmoddir) drivers_dir_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
518 -c|--conf) conffile="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
519 --confdir) confdir="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
520 --tmpdir) tmpdir_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
b552d364 521 -r|--sysroot) sysroot_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
659dc319
HB
522 -L|--stdlog) stdloglvl_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
523 --compress) compress_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
524 --prefix) prefix_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
37383f71 525 --loginstall) loginstall_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
659dc319
HB
526 --rebuild) if [ $rebuild_file == $outfile ]; then
527 force=yes
528 fi
529 shift
530 ;;
cc02093d
HH
531 -f|--force) force=yes;;
532 --kernel-only) kernel_only="yes"; no_kernel="no";;
533 --no-kernel) kernel_only="no"; no_kernel="yes";;
ab9457ef
HH
534 --print-cmdline)
535 print_cmdline="yes"; hostonly_l="yes"; kernel_only="yes"; no_kernel="yes";;
536 --early-microcode)
537 early_microcode_l="yes";;
538 --no-early-microcode)
539 early_microcode_l="no";;
cc02093d
HH
540 --strip) do_strip_l="yes";;
541 --nostrip) do_strip_l="no";;
04d18f55
HH
542 --hardlink) do_hardlink_l="yes";;
543 --nohardlink) do_hardlink_l="no";;
fd786adc 544 --noprefix) prefix_l="/";;
690396a5
VL
545 --mdadmconf) mdadmconf_l="yes";;
546 --nomdadmconf) mdadmconf_l="no";;
547 --lvmconf) lvmconf_l="yes";;
548 --nolvmconf) lvmconf_l="no";;
cc02093d 549 --debug) debug="yes";;
57258a2c 550 --profile) profile="yes";;
659dc319 551 --sshkey) sshkey="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
ee54b840 552 --logfile) logfile_l="$2"; shift;;
432196ae
553 -v|--verbose) ((verbosity_mod_l++));;
554 -q|--quiet) ((verbosity_mod_l--));;
dbf8f6ba
HH
555 -l|--local)
556 allowlocal="yes"
777f2db0 557 [[ -f "$(readlink -f "${0%/*}")/dracut-init.sh" ]] \
b093aa2d 558 && dracutbasedir="$(readlink -f "${0%/*}")"
dbf8f6ba 559 ;;
ea3c4e82
HH
560 -H|--hostonly|--host-only)
561 hostonly_l="yes" ;;
562 -N|--no-hostonly|--no-host-only)
563 hostonly_l="no" ;;
a695250e
KS
564 --hostonly-mode)
565 hostonly_mode_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
ab9457ef
HH
566 --hostonly-cmdline)
567 hostonly_cmdline_l="yes" ;;
b73e00af
HH
568 --hostonly-i18n)
569 i18n_install_all_l="no" ;;
570 --no-hostonly-i18n)
571 i18n_install_all_l="yes" ;;
ab9457ef
HH
572 --no-hostonly-cmdline)
573 hostonly_cmdline_l="no" ;;
37f2fe55
XP
574 --no-hostonly-default-device)
575 hostonly_default_device="no" ;;
324ea606 576 --persistent-policy)
659dc319 577 persistent_policy_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
cc02093d 578 --fstab) use_fstab_l="yes" ;;
ffa71b4a 579 -h|--help) long_usage; exit 1 ;;
5a66d511 580 -i|--include) include_src+=("$2"); PARMS_TO_STORE+=" '$2'";
ffa71b4a 581 shift;;
3a714439
VL
582 --bzip2) compress_l="bzip2";;
583 --lzma) compress_l="lzma";;
584 --xz) compress_l="xz";;
871c8e40 585 --lzo) compress_l="lzo";;
586 --lz4) compress_l="lz4";;
7dbadcc7 587 --zstd) compress_l="zstd";;
3a714439
VL
588 --no-compress) _no_compress_l="cat";;
589 --gzip) compress_l="gzip";;
ffa71b4a 590 --list-modules) do_list="yes";;
956af8f2
591 -M|--show-modules)
592 show_modules_l="yes"
593 ;;
5fe5c7d0 594 --keep) keep="yes";;
ec3c5951 595 --printsize) printsize="yes";;
7d848c55 596 --regenerate-all) regenerate_all="yes";;
83bb0893 597 --noimageifnotneeded) noimageifnotneeded="yes";;
80626ded 598 --reproducible) reproducible_l="yes";;
10f8df1b 599 --no-reproducible) reproducible_l="no";;
636d2d46
HH
600 --uefi) uefi="yes";;
601 --uefi-stub)
602 uefi_stub_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
4237aeb0
DT
603 --uefi-splash-image)
604 uefi_splash_image_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
636d2d46
HH
605 --kernel-image)
606 kernel_image_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
5c57209b
HH
607 --no-machineid)
608 machine_id_l="no";;
ffa71b4a
HH
609 --) shift; break;;
610
611 *) # should not even reach this point
612 printf "\n!Unknown option: '%s'\n\n" "$1" >&2; usage; exit 1;;
613 esac
614 shift
615done
616
617# getopt cannot handle multiple arguments, so just handle "-I,--include"
618# the old fashioned way
619
620while (($# > 0)); do
4eec1a22 621 if [ "${1%%=*}" == "++include" ]; then
5a66d511
HH
622 include_src+=("$2")
623 include_target+=("$3")
659dc319
HB
624 PARMS_TO_STORE+=" --include '$2' '$3'"
625 shift 2
626 fi
b368a5f3 627 shift
641cc356 628done
ffa71b4a 629
b552d364
BZ
630[[ $sysroot_l ]] && dracutsysrootdir="$sysroot_l"
631
7d848c55
HH
632if [[ $regenerate_all == "yes" ]]; then
633 ret=0
634 if [[ $kernel ]]; then
b093aa2d 635 printf -- "--regenerate-all cannot be called with a kernel version\n" >&2
7d848c55
HH
636 exit 1
637 fi
638
639 if [[ $outfile ]]; then
b093aa2d 640 printf -- "--regenerate-all cannot be called with a image file\n" >&2
7d848c55
HH
641 exit 1
642 fi
643
644 ((len=${#dracut_args[@]}))
645 for ((i=0; i < len; i++)); do
646 [[ ${dracut_args[$i]} == "--regenerate-all" ]] && \
647 unset dracut_args[$i]
648 done
649
a0120420 650 cd $dracutsysrootdir/lib/modules
7d848c55 651 for i in *; do
b29cb516 652 [[ -f $i/modules.dep ]] || [[ -f $i/modules.dep.bin ]] || continue
e8f19bcf 653 "$dracut_cmd" --kver="$i" "${dracut_args[@]}"
7d848c55
HH
654 ((ret+=$?))
655 done
656 exit $ret
657fi
658
8a5354a9 659if ! [[ $kernel ]]; then
486a1b93
HH
660 kernel=$(uname -r)
661fi
ffa71b4a 662
02b5c8e3
HH
663export LC_ALL=C
664export LANG=C
8a32bf61
HH
665unset LC_MESSAGES
666unset LC_CTYPE
d619fb5e 667unset LD_LIBRARY_PATH
45404a2a 668unset LD_PRELOAD
1fcf2d2f 669unset GREP_OPTIONS
a55711cd 670
89d44e72 671export DRACUT_LOG_LEVEL=warning
3b403b32 672[[ $debug ]] && {
89d44e72 673 export DRACUT_LOG_LEVEL=debug
c36ce334
VL
674 export PS4='${BASH_SOURCE}@${LINENO}(${FUNCNAME[0]}): ';
675 set -x
676}
677
57258a2c
HH
678[[ $profile ]] && {
679 export PS4='+ $(date "+%s.%N") ${BASH_SOURCE}@${LINENO}: ';
680 set -x
681 debug=yes
682}
683
a0120420 684[[ $dracutbasedir ]] || dracutbasedir=$dracutsysrootdir/usr/lib/dracut
5d791c0e 685
f1336ac7 686# if we were not passed a config file, try the default one
42c71947 687if [[ ! -f $conffile ]]; then
b093aa2d
HH
688 if [[ $allowlocal ]]; then
689 conffile="$dracutbasedir/dracut.conf"
690 else
a0120420 691 conffile="$dracutsysrootdir/etc/dracut.conf"
b093aa2d 692 fi
42c71947 693fi
f1336ac7 694
2c2c4580 695if [[ ! -d $confdir ]]; then
b093aa2d
HH
696 if [[ $allowlocal ]]; then
697 confdir="$dracutbasedir/dracut.conf.d"
698 else
a0120420 699 confdir="$dracutsysrootdir/etc/dracut.conf.d"
b093aa2d 700 fi
2c2c4580
HH
701fi
702
2245f372
AB
703# source our config file
704[[ -f $conffile ]] && . "$conffile"
705
2c2c4580 706# source our config dir
335bc217 707for f in $(dropindirs_sort ".conf" "$confdir" "$dracutbasedir/dracut.conf.d"); do
a42b2b81
HH
708 [[ -e $f ]] && . "$f"
709done
2c2c4580 710
5f2baf7d 711DRACUT_PATH=${DRACUT_PATH:-/sbin /bin /usr/sbin /usr/bin}
eab9b75c
HH
712
713for i in $DRACUT_PATH; do
714 rl=$i
a0120420
BZ
715 if [ -L "$dracutsysrootdir$i" ]; then
716 rl=$(readlink -f $dracutsysrootdir$i)
eab9b75c
HH
717 fi
718 if [[ "$NPATH" != *:$rl* ]] ; then
719 NPATH+=":$rl"
720 fi
721done
722export PATH="${NPATH#:}"
723unset NPATH
724
cb0913db
HH
725# these options add to the stuff in the config file
726(( ${#add_dracutmodules_l[@]} )) && add_dracutmodules+=" ${add_dracutmodules_l[@]} "
727(( ${#force_add_dracutmodules_l[@]} )) && force_add_dracutmodules+=" ${force_add_dracutmodules_l[@]} "
728(( ${#fscks_l[@]} )) && fscks+=" ${fscks_l[@]} "
729(( ${#add_fstab_l[@]} )) && add_fstab+=" ${add_fstab_l[@]} "
730(( ${#fstab_lines_l[@]} )) && fstab_lines+=( "${fstab_lines_l[@]}" )
731(( ${#install_items_l[@]} )) && install_items+=" ${install_items_l[@]} "
732(( ${#install_optional_items_l[@]} )) && install_optional_items+=" ${install_optional_items_l[@]} "
54b68829 733
f1336ac7 734# these options override the stuff in the config file
cb0913db
HH
735(( ${#dracutmodules_l[@]} )) && dracutmodules="${dracutmodules_l[@]}"
736(( ${#omit_dracutmodules_l[@]} )) && omit_dracutmodules="${omit_dracutmodules_l[@]}"
737(( ${#filesystems_l[@]} )) && filesystems="${filesystems_l[@]}"
738(( ${#fw_dir_l[@]} )) && fw_dir="${fw_dir_l[@]}"
739(( ${#libdirs_l[@]} ))&& libdirs="${libdirs_l[@]}"
c9143a63 740
e103615b 741[[ $stdloglvl_l ]] && stdloglvl=$stdloglvl_l
b991617f 742[[ ! $stdloglvl ]] && stdloglvl=4
432196ae
743stdloglvl=$((stdloglvl + verbosity_mod_l))
744((stdloglvl > 6)) && stdloglvl=6
745((stdloglvl < 0)) && stdloglvl=0
746
26537a5b 747[[ $drivers_dir_l ]] && drivers_dir=$drivers_dir_l
31f7db66 748[[ $do_strip_l ]] && do_strip=$do_strip_l
6c128565 749[[ $do_strip ]] || do_strip=yes
04d18f55
HH
750[[ $do_hardlink_l ]] && do_hardlink=$do_hardlink_l
751[[ $do_hardlink ]] || do_hardlink=yes
fd786adc
HH
752[[ $prefix_l ]] && prefix=$prefix_l
753[[ $prefix = "/" ]] && unset prefix
ba726310 754[[ $hostonly_l ]] && hostonly=$hostonly_l
ab9457ef 755[[ $hostonly_cmdline_l ]] && hostonly_cmdline=$hostonly_cmdline_l
a695250e 756[[ $hostonly_mode_l ]] && hostonly_mode=$hostonly_mode_l
30f6c80d 757[[ "$hostonly" == "yes" ]] && ! [[ $hostonly_cmdline ]] && hostonly_cmdline="yes"
b73e00af 758[[ $i18n_install_all_l ]] && i18n_install_all=$i18n_install_all_l
3411ad66 759[[ $persistent_policy_l ]] && persistent_policy=$persistent_policy_l
7c179686 760[[ $use_fstab_l ]] && use_fstab=$use_fstab_l
2f02ae9d 761[[ $mdadmconf_l ]] && mdadmconf=$mdadmconf_l
7a34efa5 762[[ $lvmconf_l ]] && lvmconf=$lvmconf_l
a0120420
BZ
763[[ $dracutbasedir ]] || dracutbasedir=$dracutsysrootdir/usr/lib/dracut
764[[ $fw_dir ]] || fw_dir="$dracutsysrootdir/lib/firmware/updates:$dracutsysrootdir/lib/firmware:$dracutsysrootdir/lib/firmware/$kernel"
882c4c5a 765[[ $tmpdir_l ]] && tmpdir="$tmpdir_l"
a0120420 766[[ $tmpdir ]] || tmpdir=$dracutsysrootdir/var/tmp
871c8e40 767[[ $INITRD_COMPRESS ]] && compress=$INITRD_COMPRESS
3a714439 768[[ $compress_l ]] && compress=$compress_l
956af8f2 769[[ $show_modules_l ]] && show_modules=$show_modules_l
25b45979 770[[ $nofscks_l ]] && nofscks="yes"
ff3953ef 771[[ $ro_mnt_l ]] && ro_mnt="yes"
b7c770e1 772[[ $early_microcode_l ]] && early_microcode=$early_microcode_l
b25ef46f 773[[ $early_microcode ]] || early_microcode=yes
d613d88d
JW
774[[ $early_microcode_image_dir ]] || early_microcode_image_dir=('/boot')
775[[ $early_microcode_image_name ]] || \
776 early_microcode_image_name=('intel-uc.img' 'intel-ucode.img' 'amd-uc.img' 'amd-ucode.img' 'early_ucode.cpio' 'microcode.cpio')
ee54b840 777[[ $logfile_l ]] && logfile="$logfile_l"
80626ded 778[[ $reproducible_l ]] && reproducible="$reproducible_l"
37383f71 779[[ $loginstall_l ]] && loginstall="$loginstall_l"
636d2d46 780[[ $uefi_stub_l ]] && uefi_stub="$uefi_stub_l"
4237aeb0 781[[ $uefi_splash_image_l ]] && uefi_splash_image="$uefi_splash_image_l"
636d2d46 782[[ $kernel_image_l ]] && kernel_image="$kernel_image_l"
5c57209b
HH
783[[ $machine_id_l ]] && machine_id="$machine_id_l"
784
785if ! [[ $outfile ]]; then
786 if [[ $machine_id != "no" ]]; then
a0120420 787 [[ -f $dracutsysrootdir/etc/machine-id ]] && read MACHINE_ID < $dracutsysrootdir/etc/machine-id
5c57209b
HH
788 fi
789
790 if [[ $uefi == "yes" ]]; then
5a962b59
MR
791 if [[ -n "$uefi_secureboot_key" && -z "$uefi_secureboot_cert" ]] || [[ -z $uefi_secureboot_key && -n $uefi_secureboot_cert ]]; then
792 dfatal "Need 'uefi_secureboot_key' and 'uefi_secureboot_cert' both to be set."
793 exit 1
794 fi
795
796 if [[ -n "$uefi_secureboot_key" && -n "$uefi_secureboot_cert" ]] && !command -v sbsign &>/dev/null; then
797 dfatal "Need 'sbsign' to create a signed UEFI executable"
798 exit 1
799 fi
800
a0120420 801 BUILD_ID=$(cat $dracutsysrootdir/etc/os-release $dracutsysrootdir/usr/lib/os-release \
5c57209b
HH
802 | while read -r line || [[ $line ]]; do \
803 [[ $line =~ BUILD_ID\=* ]] && eval "$line" && echo "$BUILD_ID" && break; \
804 done)
a0120420
BZ
805 if [[ -z $dracutsysrootdir ]]; then
806 if [[ -d /efi ]] && mountpoint -q /efi; then
807 efidir=/efi/EFI
808 else
809 efidir=/boot/EFI
810 if [[ -d $dracutsysrootdir/boot/efi/EFI ]]; then
811 efidir=/boot/efi/EFI
812 fi
813 fi
5c57209b
HH
814 else
815 efidir=/boot/EFI
a0120420 816 if [[ -d $dracutsysrootdir/boot/efi/EFI ]]; then
5c57209b
HH
817 efidir=/boot/efi/EFI
818 fi
819 fi
a0120420
BZ
820 mkdir -p "$dracutsysrootdir$efidir/Linux"
821 outfile="$dracutsysrootdir$efidir/Linux/linux-$kernel${MACHINE_ID:+-${MACHINE_ID}}${BUILD_ID:+-${BUILD_ID}}.efi"
5c57209b 822 else
a0120420 823 if [[ -e "$dracutsysrootdir/boot/vmlinuz-$kernel" ]]; then
791d8016 824 outfile="/boot/initramfs-$kernel.img"
a0120420
BZ
825 elif [[ $MACHINE_ID ]] && ( [[ -d $dracutsysrootdir/boot/${MACHINE_ID} ]] || [[ -L $dracutsysrootdir/boot/${MACHINE_ID} ]] ); then
826 outfile="$dracutsysrootdir/boot/${MACHINE_ID}/$kernel/initrd"
5c57209b 827 else
a0120420 828 outfile="$dracutsysrootdir/boot/initramfs-$kernel.img"
5c57209b
HH
829 fi
830 fi
831fi
80626ded 832
ddfd1d10 833# eliminate IFS hackery when messing with fw_dir
794b2d2c 834export DRACUT_FIRMWARE_PATH=${fw_dir// /:}
ddfd1d10 835fw_dir=${fw_dir//:/ }
9a8a00cf 836
3838dc47 837# check for logfile and try to create one if it doesn't exist
838if [[ -n "$logfile" ]];then
839 if [[ ! -f "$logfile" ]];then
840 touch "$logfile"
841 if [ ! $? -eq 0 ] ;then
842 printf "%s\n" "dracut: touch $logfile failed." >&2
843 fi
844 fi
845fi
846
3a714439 847# handle compression options.
a0120420
BZ
848DRACUT_COMPRESS_BZIP2=${DRACUT_COMPRESS_BZIP2:-bzip2}
849DRACUT_COMPRESS_LBZIP2=${DRACUT_COMPRESS_LBZIP2:-lbzip2}
850DRACUT_COMPRESS_LZMA=${DRACUT_COMPRESS_LZMA:-lzma}
851DRACUT_COMPRESS_XZ=${DRACUT_COMPRESS_XZ:-xz}
852DRACUT_COMPRESS_GZIP=${DRACUT_COMPRESS_GZIP:-gzip}
853DRACUT_COMPRESS_PIGZ=${DRACUT_COMPRESS_PIGZ:-pigz}
854DRACUT_COMPRESS_LZOP=${DRACUT_COMPRESS_LZOP:-lzop}
855DRACUT_COMPRESS_ZSTD=${DRACUT_COMPRESS_ZSTD:-zstd}
856DRACUT_COMPRESS_LZ4=${DRACUT_COMPRESS_LZ4:-lz4}
857DRACUT_COMPRESS_CAT=${DRACUT_COMPRESS_CAT:-cat}
858
859if [[ $_no_compress_l = "$DRACUT_COMPRESS_CAT" ]]; then
860 compress="$DRACUT_COMPRESS_CAT"
693b7a32
HH
861fi
862
863if ! [[ $compress ]]; then
864 # check all known compressors, if none specified
a0120420 865 for i in $DRACUT_COMPRESS_PIGZ $DRACUT_COMPRESS_GZIP $DRACUT_COMPRESS_LZ4 $DRACUT_COMPRESS_LZOP $ $DRACUT_COMPRESS_ZSTD $DRACUT_COMPRESS_LZMA $DRACUT_COMPRESS_XZ $DRACUT_COMPRESS_LBZIP2 $OMPRESS_BZIP2 $DRACUT_COMPRESS_CAT; do
693b7a32
HH
866 command -v "$i" &>/dev/null || continue
867 compress="$i"
868 break
869 done
870 if [[ $compress = cat ]]; then
871 printf "%s\n" "dracut: no compression tool available. Initramfs image is going to be big." >&2
872 fi
873fi
874
875# choose the right arguments for the compressor
3a714439 876case $compress in
693b7a32 877 bzip2|lbzip2)
a0120420
BZ
878 if [[ "$compress" = lbzip2 ]] || command -v $DRACUT_COMPRESS_LBZIP2 &>/dev/null; then
879 compress="$DRACUT_COMPRESS_LBZIP2 -9"
693b7a32 880 else
a0120420 881 compress="$DRACUT_COMPRESS_BZIP2 -9"
693b7a32
HH
882 fi
883 ;;
884 lzma)
a0120420 885 compress="$DRACUT_COMPRESS_LZMA -9 -T0"
693b7a32
HH
886 ;;
887 xz)
a0120420 888 compress="$DRACUT_COMPRESS_XZ --check=crc32 --lzma2=dict=1MiB -T0"
693b7a32
HH
889 ;;
890 gzip|pigz)
a0120420
BZ
891 if [[ "$compress" = pigz ]] || command -v $DRACUT_COMPRESS_PIGZ &>/dev/null; then
892 compress="$DRACUT_COMPRESS_PIGZ -9 -n -T -R"
893 elif command -v gzip &>/dev/null && $DRACUT_COMPRESS_GZIP --help 2>&1 | grep -q rsyncable; then
894 compress="$DRACUT_COMPRESS_GZIP -n -9 --rsyncable"
693b7a32 895 else
a0120420 896 compress="$DRACUT_COMPRESS_GZIP -n -9"
66fd7e43
HH
897 fi
898 ;;
693b7a32 899 lzo|lzop)
a0120420 900 compress="$DRACUT_COMPRESS_LZOP -9"
693b7a32
HH
901 ;;
902 lz4)
a0120420 903 compress="$DRACUT_COMPRESS_LZ4 -l -9"
693b7a32 904 ;;
7dbadcc7 905 zstd)
a0120420 906 compress="$DRACUT_COMPRESS_ZSTD -15 -q -T0"
7dbadcc7 907 ;;
3a714439 908esac
3a714439 909
ba726310 910[[ $hostonly = yes ]] && hostonly="-h"
ba67b923 911[[ $hostonly != "-h" ]] && unset hostonly
ba726310 912
a695250e
KS
913case $hostonly_mode in
914 '')
915 [[ $hostonly ]] && hostonly_mode="sloppy" ;;
916 sloppy|strict)
917 if [[ ! $hostonly ]]; then
918 unset hostonly_mode
919 fi
920 ;;
921 *)
922 printf "%s\n" "dracut: Invalid hostonly mode '$hostonly_mode'." >&2
923 exit 1
924esac
925
80626ded
HH
926[[ $reproducible == yes ]] && DRACUT_REPRODUCIBLE=1
927
f668e717
DC
928case "${drivers_dir}" in
929 ''|*lib/modules/${kernel}|*lib/modules/${kernel}/) ;;
930 *)
931 [[ "$DRACUT_KMODDIR_OVERRIDE" ]] || {
932 printf "%s\n" "dracut: -k/--kmoddir path must contain \"lib/modules\" as a parent of your kernel module directory,"
933 printf "%s\n" "dracut: or modules may not be placed in the correct location inside the initramfs."
934 printf "%s\n" "dracut: was given: ${drivers_dir}"
935 printf "%s\n" "dracut: expected: $(dirname ${drivers_dir})/lib/modules/${kernel}"
936 printf "%s\n" "dracut: Please move your modules into the correct directory structure and pass the new location,"
937 printf "%s\n" "dracut: or set DRACUT_KMODDIR_OVERRIDE=1 to ignore this check."
938 exit 1
939 }
940 ;;
941esac
942
bafc82e7
DD
943readonly TMPDIR="$(realpath -e "$tmpdir")"
944[ -d "$TMPDIR" ] || {
945 printf "%s\n" "dracut: Invalid tmpdir '$tmpdir'." >&2
946 exit 1
947}
ecbdff68
TM
948
949if findmnt --raw -n --target "$tmpdir" --output=options | grep -q noexec; then
950 [[ $debug == yes ]] && printf "%s\n" "dracut: Tmpdir '$tmpdir' is mounted with 'noexec'."
951 noexec=1
952fi
953
62c00a88
HH
954readonly DRACUT_TMPDIR="$(mktemp -p "$TMPDIR/" -d -t dracut.XXXXXX)"
955[ -d "$DRACUT_TMPDIR" ] || {
956 printf "%s\n" "dracut: mktemp -p '$TMPDIR/' -d -t dracut.XXXXXX failed." >&2
26c231f1
HH
957 exit 1
958}
959
d008b6b8 960# clean up after ourselves no matter how we die.
bbaa0d59
HH
961trap '
962 ret=$?;
62c00a88 963 [[ $keep ]] && echo "Not removing $DRACUT_TMPDIR." >&2 || { [[ $DRACUT_TMPDIR ]] && rm -rf -- "$DRACUT_TMPDIR"; };
bbaa0d59
HH
964 exit $ret;
965 ' EXIT
966
d008b6b8
HH
967# clean up after ourselves no matter how we die.
968trap 'exit 1;' SIGINT
969
3889234f
HH
970readonly initdir="${DRACUT_TMPDIR}/initramfs"
971mkdir "$initdir"
972
973if [[ $early_microcode = yes ]] || ( [[ $acpi_override = yes ]] && [[ -d $acpi_table_dir ]] ); then
974 readonly early_cpio_dir="${DRACUT_TMPDIR}/earlycpio"
975 mkdir "$early_cpio_dir"
976fi
977
ecbdff68 978[[ -n "$dracutsysrootdir" || "$noexec" ]] || export DRACUT_RESOLVE_LAZY="1"
89d44e72 979
535f61ca
HH
980if [[ $print_cmdline ]]; then
981 stdloglvl=0
982 sysloglvl=0
983 fileloglvl=0
984 kmsgloglvl=0
985fi
986
e27ecc9a
HH
987if [[ -f $dracutbasedir/dracut-version.sh ]]; then
988 . $dracutbasedir/dracut-version.sh
989fi
990
777f2db0
HH
991if [[ -f $dracutbasedir/dracut-init.sh ]]; then
992 . $dracutbasedir/dracut-init.sh
adbc8a42 993else
777f2db0 994 printf "%s\n" "dracut: Cannot find $dracutbasedir/dracut-init.sh." >&2
b093aa2d 995 printf "%s\n" "dracut: Are you running from a git checkout?" >&2
e8f19bcf 996 printf "%s\n" "dracut: Try passing -l as an argument to $dracut_cmd" >&2
cc02093d 997 exit 1
adbc8a42 998fi
22fd1627 999
106255af
HH
1000if [[ $no_kernel != yes ]] && ! [[ -d $srcmods ]]; then
1001 printf "%s\n" "dracut: Cannot find module directory $srcmods" >&2
1002 printf "%s\n" "dracut: and --no-kernel was not specified" >&2
1003 exit 1
1004fi
1005
1743473b 1006if ! [[ $print_cmdline ]]; then
a0120420
BZ
1007 inst $DRACUT_TESTBIN
1008 if ! $DRACUT_INSTALL ${initdir:+-D "$initdir"} ${dracutsysrootdir:+-r "$dracutsysrootdir"} -R "$DRACUT_TESTBIN" &>/dev/null; then
1743473b
HH
1009 unset DRACUT_RESOLVE_LAZY
1010 export DRACUT_RESOLVE_DEPS=1
1011 fi
1012 rm -fr -- ${initdir}/*
bfd2e8c2 1013fi
bfd2e8c2 1014
552ecca6 1015dracutfunctions=$dracutbasedir/dracut-functions.sh
5cad5bb5 1016export dracutfunctions
9a8a00cf 1017
cb0913db 1018(( ${#drivers_l[@]} )) && drivers="${drivers_l[@]}"
fcbcb252
HH
1019drivers=${drivers/-/_}
1020
cb0913db 1021(( ${#add_drivers_l[@]} )) && add_drivers+=" ${add_drivers_l[@]} "
fcbcb252
HH
1022add_drivers=${add_drivers/-/_}
1023
cb0913db 1024(( ${#force_drivers_l[@]} )) && force_drivers+=" ${force_drivers_l[@]} "
cea907f6
TR
1025force_drivers=${force_drivers/-/_}
1026
cb0913db 1027(( ${#omit_drivers_l[@]} )) && omit_drivers+=" ${omit_drivers_l[@]} "
fcbcb252
HH
1028omit_drivers=${omit_drivers/-/_}
1029
cb0913db 1030(( ${#kernel_cmdline_l[@]} )) && kernel_cmdline+=" ${kernel_cmdline_l[@]} "
d20fb951 1031
34248c92 1032omit_drivers_corrected=""
fcbcb252 1033for d in $omit_drivers; do
b093aa2d 1034 [[ " $drivers $add_drivers " == *\ $d\ * ]] && continue
cea907f6 1035 [[ " $drivers $force_drivers " == *\ $d\ * ]] && continue
34248c92 1036 omit_drivers_corrected+="$d|"
fcbcb252 1037done
34248c92 1038omit_drivers="${omit_drivers_corrected%|}"
fcbcb252
HH
1039unset omit_drivers_corrected
1040
ffa71b4a
HH
1041# prepare args for logging
1042for ((i=0; i < ${#dracut_args[@]}; i++)); do
b093aa2d 1043 [[ "${dracut_args[$i]}" == *\ * ]] && \
ffa71b4a 1044 dracut_args[$i]="\"${dracut_args[$i]}\""
a4210166 1045 #" keep vim happy
ffa71b4a 1046done
535f61ca 1047
e8f19bcf 1048dinfo "Executing: $dracut_cmd ${dracut_args[@]}"
58dad702 1049
5b11bb73
HH
1050[[ $do_list = yes ]] && {
1051 for mod in $dracutbasedir/modules.d/*; do
1052 [[ -d $mod ]] || continue;
d8e8e14e
1053 [[ -e $mod/install || -e $mod/installkernel || \
1054 -e $mod/module-setup.sh ]] || continue
b093aa2d 1055 printf "%s\n" "${mod##*/??}"
5b11bb73
HH
1056 done
1057 exit 0
1058}
1059
66ac3cd1 1060# This is kinda legacy -- eventually it should go away.
f1336ac7 1061case $dracutmodules in
66ac3cd1 1062 ""|auto) dracutmodules="all" ;;
f1336ac7 1063esac
e12aac5e 1064
454771cd 1065abs_outfile=$(readlink -f "$outfile") && outfile="$abs_outfile"
ec9315e5 1066
c8b35bf9 1067
9d88e893 1068[[ -d $dracutsysrootdir$systemdutildir ]] \
c8b35bf9
ДГ
1069 || systemdutildir=$(pkg-config systemd --variable=systemdutildir 2>/dev/null)
1070
9d88e893
BZ
1071if ! [[ -d "$dracutsysrootdir$systemdutildir" ]]; then
1072 [[ -e $dracutsysrootdir/lib/systemd/systemd-udevd ]] && systemdutildir=/lib/systemd
1073 [[ -e $dracutsysrootdir/usr/lib/systemd/systemd-udevd ]] && systemdutildir=/usr/lib/systemd
c8b35bf9
ДГ
1074fi
1075
1076
693b7a32
HH
1077if [[ $no_kernel != yes ]] && [[ -d $srcmods ]]; then
1078 if ! [[ -f $srcmods/modules.dep ]]; then
b019952f
HH
1079 if [[ -n "$(find "$srcmods" -name '*.ko*')" ]]; then
1080 dfatal "$srcmods/modules.dep is missing. Did you run depmod?"
1081 exit 1
1082 else
1083 dwarn "$srcmods/modules.dep is missing. Did you run depmod?"
1084 fi
693b7a32
HH
1085 elif ! ( command -v gzip &>/dev/null && command -v xz &>/dev/null); then
1086 read _mod < $srcmods/modules.dep
1087 _mod=${_mod%%:*}
1088 if [[ -f $srcmods/"$_mod" ]]; then
1089 # Check, if kernel modules are compressed, and if we can uncompress them
1090 case "$_mod" in
1091 *.ko.gz) kcompress=gzip;;
1092 *.ko.xz) kcompress=xz;;
1093 esac
1094 if [[ $kcompress ]]; then
1095 if ! command -v "$kcompress" &>/dev/null; then
1096 dfatal "Kernel modules are compressed with $kcompress, but $kcompress is not available."
1097 exit 1
1098 fi
1099 fi
1100 fi
1101 fi
5db6ca5a 1102fi
fe1484f3 1103
96cf7270
HH
1104if [[ ! $print_cmdline ]]; then
1105 if [[ -f $outfile && ! $force ]]; then
1106 dfatal "Will not override existing initramfs ($outfile) without --force"
1107 exit 1
1108 fi
1109
1110 outdir=${outfile%/*}
1111 [[ $outdir ]] || outdir="/"
1112
1113 if [[ ! -d "$outdir" ]]; then
1114 dfatal "Can't write to $outdir: Directory $outdir does not exist or is not accessible."
1115 exit 1
1116 elif [[ ! -w "$outdir" ]]; then
1117 dfatal "No permission to write to $outdir."
1118 exit 1
1119 elif [[ -f "$outfile" && ! -w "$outfile" ]]; then
1120 dfatal "No permission to write $outfile."
1121 exit 1
1122 fi
37383f71
HH
1123
1124 if [[ $loginstall ]]; then
1125 if ! mkdir -p "$loginstall"; then
1126 dfatal "Could not create directory to log installed files to '$loginstall'."
1127 exit 1
1128 fi
1129 loginstall=$(readlink -f "$loginstall")
1130 fi
636d2d46
HH
1131
1132 if [[ $uefi = yes ]]; then
1133 if ! command -v objcopy &>/dev/null; then
1134 dfatal "Need 'objcopy' to create a UEFI executable"
1135 exit 1
1136 fi
1137 unset EFI_MACHINE_TYPE_NAME
12f023ab 1138 case $(uname -m) in
636d2d46
HH
1139 x86_64)
1140 EFI_MACHINE_TYPE_NAME=x64;;
1141 ia32)
1142 EFI_MACHINE_TYPE_NAME=ia32;;
1143 *)
12f023ab 1144 dfatal "Architecture '$(uname -m)' not supported to create a UEFI executable"
636d2d46
HH
1145 exit 1
1146 ;;
1147 esac
1148
1149 if ! [[ -s $uefi_stub ]]; then
1150 for uefi_stub in \
a0120420
BZ
1151 $dracutsysrootdir"${systemdutildir}/boot/efi/linux${EFI_MACHINE_TYPE_NAME}.efi.stub" \
1152 "$dracutsysrootdir/usr/lib/gummiboot/linux${EFI_MACHINE_TYPE_NAME}.efi.stub"; do
636d2d46
HH
1153 [[ -s $uefi_stub ]] || continue
1154 break
1155 done
1156 fi
1157 if ! [[ -s $uefi_stub ]]; then
1158 dfatal "Can't find a uefi stub '$uefi_stub' to create a UEFI executable"
1159 exit 1
1160 fi
1161
1162 if ! [[ $kernel_image ]]; then
a0120420 1163 for kernel_image in "$dracutsysrootdir/lib/modules/$kernel/vmlinuz" "$dracutsysrootdir/boot/vmlinuz-$kernel"; do
636d2d46
HH
1164 [[ -s "$kernel_image" ]] || continue
1165 break
1166 done
1167 fi
1168 if ! [[ -s $kernel_image ]]; then
1169 dfatal "Can't find a kernel image '$kernel_image' to create a UEFI executable"
1170 exit 1
1171 fi
1172 fi
ec9315e5
JK
1173fi
1174
940169e8
HH
1175if [[ $acpi_override = yes ]] && ! ( check_kernel_config CONFIG_ACPI_TABLE_UPGRADE || check_kernel_config CONFIG_ACPI_INITRD_TABLE_OVERRIDE ); then
1176 dwarn "Disabling ACPI override, because kernel does not support it. CONFIG_ACPI_INITRD_TABLE_OVERRIDE!=y or CONFIG_ACPI_TABLE_UPGRADE!=y"
8e3f6537
HH
1177 unset acpi_override
1178fi
1179
1180if [[ $early_microcode = yes ]]; then
1181 if [[ $hostonly ]]; then
1182 [[ $(get_cpu_vendor) == "AMD" ]] \
875426f2 1183 && ! check_kernel_config CONFIG_MICROCODE_AMD \
8e3f6537
HH
1184 && unset early_microcode
1185 [[ $(get_cpu_vendor) == "Intel" ]] \
875426f2 1186 && ! check_kernel_config CONFIG_MICROCODE_INTEL \
8e3f6537
HH
1187 && unset early_microcode
1188 else
875426f2
HH
1189 ! check_kernel_config CONFIG_MICROCODE_AMD \
1190 && ! check_kernel_config CONFIG_MICROCODE_INTEL \
8e3f6537
HH
1191 && unset early_microcode
1192 fi
1193 [[ $early_microcode != yes ]] \
875426f2 1194 && dwarn "Disabling early microcode, because kernel does not support it. CONFIG_MICROCODE_[AMD|INTEL]!=y"
8e3f6537
HH
1195fi
1196
f6f74096
DD
1197# Need to be able to have non-root users read stuff (rpcbind etc)
1198chmod 755 "$initdir"
1199
5bfa3b36
HH
1200if [[ $hostonly ]]; then
1201 for i in /sys /proc /run /dev; do
5e601454 1202 if ! findmnt --target "$i" &>/dev/null; then
5bfa3b36
HH
1203 dwarning "Turning off host-only mode: '$i' is not mounted!"
1204 unset hostonly
1205 fi
1206 done
1207fi
1208
d351541e
HH
1209declare -A host_fs_types
1210
cd7ff122
AW
1211for line in "${fstab_lines[@]}"; do
1212 set -- $line
6df52351 1213 dev="$1"
cd7ff122 1214 #dev mp fs fsopts
6df52351
TR
1215 case "$dev" in
1216 UUID=*)
1217 dev=$(blkid -l -t UUID=${dev#UUID=} -o device)
1218 ;;
1219 LABEL=*)
1220 dev=$(blkid -l -t LABEL=${dev#LABEL=} -o device)
1221 ;;
1222 PARTUUID=*)
1223 dev=$(blkid -l -t PARTUUID=${dev#PARTUUID=} -o device)
1224 ;;
1225 PARTLABEL=*)
1226 dev=$(blkid -l -t PARTLABEL=${dev#PARTLABEL=} -o device)
1227 ;;
1228 esac
1229 [ -z "$dev" ] && dwarn "Bad fstab entry $@" && continue
1cadc26f
HH
1230 if [[ "$3" == btrfs ]]; then
1231 for i in $(btrfs_devs "$2"); do
1232 push_host_devs "$i"
1233 done
1234 fi
6df52351
TR
1235 push_host_devs "$dev"
1236 host_fs_types["$dev"]="$3"
cd7ff122
AW
1237done
1238
1239for f in $add_fstab; do
b093aa2d 1240 [[ -e $f ]] || continue
6d58fa27 1241 while read dev rest || [ -n "$dev" ]; do
118ca9ec 1242 push_host_devs "$dev"
b093aa2d
HH
1243 done < "$f"
1244done
1245
1246for dev in $add_device; do
118ca9ec 1247 push_host_devs "$dev"
cd7ff122
AW
1248done
1249
c586b033 1250if (( ${#add_device_l[@]} )); then
694725ab
HH
1251 add_device+=" ${add_device_l[@]} "
1252 push_host_devs "${add_device_l[@]}"
c586b033
CG
1253fi
1254
37f2fe55 1255if [[ $hostonly ]] && [[ "$hostonly_default_device" != "no" ]]; then
480d772f
HH
1256 # in hostonly mode, determine all devices, which have to be accessed
1257 # and examine them for filesystem types
1258
bcfbddef 1259 for mp in \
7ae5d9d1
HH
1260 "/" \
1261 "/etc" \
d624f606
HH
1262 "/bin" \
1263 "/sbin" \
1264 "/lib" \
1265 "/lib64" \
af75a298 1266 "/usr" \
9fc14445
HH
1267 "/usr/bin" \
1268 "/usr/sbin" \
1269 "/usr/lib" \
1270 "/usr/lib64" \
a956a464
HH
1271 "/boot" \
1272 "/boot/efi" \
33260dac 1273 "/boot/zipl" \
a956a464 1274 ;
bcfbddef 1275 do
a0120420 1276 mp=$(readlink -f "$dracutsysrootdir$mp")
7ae5d9d1 1277 mountpoint "$mp" >/dev/null 2>&1 || continue
a4f7b504 1278 _dev=$(find_block_device "$mp")
e95b6723 1279 _bdev=$(readlink -f "/dev/block/$_dev")
a4f7b504 1280 [[ -b $_bdev ]] && _dev=$_bdev
5a66d511 1281 [[ "$mp" == "/" ]] && root_devs+=("$_dev")
118ca9ec 1282 push_host_devs "$_dev"
1cadc26f
HH
1283 if [[ $(find_mp_fstype "$mp") == btrfs ]]; then
1284 for i in $(btrfs_devs "$mp"); do
5a66d511 1285 [[ "$mp" == "/" ]] && root_devs+=("$i")
1cadc26f
HH
1286 push_host_devs "$i"
1287 done
1288 fi
7ae5d9d1 1289 done
dd587549 1290
a0120420
BZ
1291 # TODO - with sysroot, /proc/swaps is not relevant
1292 if [[ -f /proc/swaps ]] && [[ -f $dracutsysrootdir/etc/fstab ]]; then
6d58fa27 1293 while read dev type rest || [ -n "$dev" ]; do
7fd850d5
HH
1294 [[ -b $dev ]] || continue
1295 [[ "$type" == "partition" ]] || continue
1296
6d58fa27 1297 while read _d _m _t _o _r || [ -n "$_d" ]; do
7fd850d5
HH
1298 [[ "$_d" == \#* ]] && continue
1299 [[ $_d ]] || continue
546d5dac
HH
1300 [[ $_t != "swap" ]] && continue
1301 [[ $_m != "swap" ]] && [[ $_m != "none" ]] && continue
7fd850d5 1302 [[ "$_o" == *noauto* ]] && continue
c82a1133 1303 _d=$(expand_persistent_dev "$_d")
7fd850d5
HH
1304 [[ "$_d" -ef "$dev" ]] || continue
1305
a0120420 1306 if [[ -f $dracutsysrootdir/etc/crypttab ]]; then
6d58fa27 1307 while read _mapper _a _p _o || [ -n "$_mapper" ]; do
7fd850d5
HH
1308 [[ $_mapper = \#* ]] && continue
1309 [[ "$_d" -ef /dev/mapper/"$_mapper" ]] || continue
1310 [[ "$_o" ]] || _o="$_p"
64ae4e07
HH
1311 # skip entries with password files
1312 [[ "$_p" == /* ]] && [[ -f $_p ]] && continue 2
1743473b 1313 # skip mkswap swap
7fd850d5 1314 [[ $_o == *swap* ]] && continue 2
a0120420 1315 done < $dracutsysrootdir/etc/crypttab
7fd850d5 1316 fi
bcfbddef 1317
3e3ed34f
CG
1318 _dev="$(readlink -f "$dev")"
1319 push_host_devs "$_dev"
5a66d511 1320 swap_devs+=("$_dev")
7fd850d5 1321 break
a0120420 1322 done < $dracutsysrootdir/etc/fstab
7fd850d5
HH
1323 done < /proc/swaps
1324 fi
916559e0
HH
1325
1326 # collect all "x-initrd.mount" entries from /etc/fstab
a0120420 1327 if [[ -f $dracutsysrootdir/etc/fstab ]]; then
916559e0
HH
1328 while read _d _m _t _o _r || [ -n "$_d" ]; do
1329 [[ "$_d" == \#* ]] && continue
1330 [[ $_d ]] || continue
1331 [[ "$_o" != *x-initrd.mount* ]] && continue
1332 _dev=$(expand_persistent_dev "$_d")
1333 _dev="$(readlink -f "$_dev")"
1cadc26f
HH
1334 [[ -b $_dev ]] || continue
1335
1336 push_host_devs "$_dev"
1337 if [[ "$_t" == btrfs ]]; then
bfa4e45f 1338 for i in $(btrfs_devs "$_m"); do
1cadc26f
HH
1339 push_host_devs "$i"
1340 done
1341 fi
a0120420 1342 done < $dracutsysrootdir/etc/fstab
916559e0 1343 fi
7ae5d9d1 1344fi
7ae5d9d1 1345
3c4315fa
HH
1346unset m
1347unset rest
1348
dba20559 1349_get_fs_type() {
19bab59c 1350 [[ $1 ]] || return
e41f3f90
HH
1351 if [[ -b /dev/block/$1 ]]; then
1352 ID_FS_TYPE=$(get_fs_env "/dev/block/$1") && host_fs_types["$(readlink -f "/dev/block/$1")"]="$ID_FS_TYPE"
19bab59c 1353 return 1
cd7ff122 1354 fi
e41f3f90
HH
1355 if [[ -b $1 ]]; then
1356 ID_FS_TYPE=$(get_fs_env "$1") && host_fs_types["$(readlink -f "$1")"]="$ID_FS_TYPE"
19bab59c 1357 return 1
4f10ae2b 1358 fi
b093aa2d 1359 if fstype=$(find_dev_fstype "$1"); then
dba20559 1360 host_fs_types["$1"]="$fstype"
19bab59c 1361 return 1
cd7ff122
AW
1362 fi
1363 return 1
dba20559
HH
1364}
1365
3721635b 1366for dev in "${host_devs[@]}"; do
dba20559
HH
1367 _get_fs_type "$dev"
1368 check_block_and_slaves_all _get_fs_type "$(get_maj_min "$dev")"
cd7ff122
AW
1369done
1370
8df0b654
HH
1371for dev in "${!host_fs_types[@]}"; do
1372 [[ ${host_fs_types[$dev]} = "reiserfs" ]] || [[ ${host_fs_types[$dev]} = "xfs" ]] || continue
1373 rootopts=$(find_dev_fsopts "$dev")
1374 if [[ ${host_fs_types[$dev]} = "reiserfs" ]]; then
1375 journaldev=$(fs_get_option $rootopts "jdev")
1376 elif [[ ${host_fs_types[$dev]} = "xfs" ]]; then
1377 journaldev=$(fs_get_option $rootopts "logdev")
1378 fi
1379 if [[ $journaldev ]]; then
1380 dev="$(readlink -f "$dev")"
118ca9ec 1381 push_host_devs "$dev"
8df0b654
HH
1382 _get_fs_type "$dev"
1383 check_block_and_slaves_all _get_fs_type "$(get_maj_min "$dev")"
1384 fi
1385done
1386
a0120420 1387[[ -d $dracutsysrootdir$udevdir ]] \
b093aa2d 1388 || udevdir="$(pkg-config udev --variable=udevdir 2>/dev/null)"
a0120420
BZ
1389if ! [[ -d "$dracutsysrootdir$udevdir" ]]; then
1390 [[ -e $dracutsysrootdir/lib/udev/ata_id ]] && udevdir=/lib/udev
1391 [[ -e $dracutsysrootdir/usr/lib/udev/ata_id ]] && udevdir=/usr/lib/udev
d1615612
HH
1392fi
1393
a0120420 1394[[ -d $dracutsysrootdir$systemdsystemunitdir ]] \
cb8def95
HH
1395 || systemdsystemunitdir=$(pkg-config systemd --variable=systemdsystemunitdir 2>/dev/null)
1396
a0120420 1397[[ -d "$dracutsysrootdir$systemdsystemunitdir" ]] || systemdsystemunitdir=${systemdutildir}/system
d1615612 1398
a0120420 1399[[ -d $dracutsysrootdir$systemdsystemconfdir ]] \
cb8def95
HH
1400 || systemdsystemconfdir=$(pkg-config systemd --variable=systemdsystemconfdir 2>/dev/null)
1401
a0120420 1402[[ -d "$dracutsysrootdir$systemdsystemconfdir" ]] || systemdsystemconfdir=/etc/systemd/system
cb8def95 1403
a0120420 1404[[ -d $dracutsysrootdir$tmpfilesdir ]] \
3a04bdde
HH
1405 || tmpfilesdir=$(pkg-config systemd --variable=tmpfilesdir 2>/dev/null)
1406
a0120420
BZ
1407if ! [[ -d "$dracutsysrootdir$tmpfilesdir" ]]; then
1408 [[ -d $dracutsysrootdir/lib/tmpfiles.d ]] && tmpfilesdir=/lib/tmpfiles.d
1409 [[ -d $dracutsysrootdir/usr/lib/tmpfiles.d ]] && tmpfilesdir=/usr/lib/tmpfiles.d
3a04bdde
HH
1410fi
1411
ab2f95e4
HH
1412export initdir dracutbasedir \
1413 dracutmodules force_add_dracutmodules add_dracutmodules omit_dracutmodules \
1414 mods_to_load \
e103615b 1415 fw_dir drivers_dir debug no_kernel kernel_only \
5634a311 1416 omit_drivers mdadmconf lvmconf root_devs \
ff3953ef 1417 use_fstab fstab_lines libdirs fscks nofscks ro_mnt \
1e64e493 1418 stdloglvl sysloglvl fileloglvl kmsgloglvl logfile \
3e3ed34f 1419 debug host_fs_types host_devs swap_devs sshkey add_fstab \
cb8def95 1420 DRACUT_VERSION udevdir prefix filesystems drivers \
3c4315fa 1421 systemdutildir systemdsystemunitdir systemdsystemconfdir \
3f60444e 1422 hostonly_cmdline loginstall \
3a04bdde 1423 tmpfilesdir
f4fff04e 1424
1743473b
HH
1425mods_to_load=""
1426# check all our modules to see if they should be sourced.
1427# This builds a list of modules that we will install next.
1428for_each_module_dir check_module
1429for_each_module_dir check_mount
1430
88c86ac7 1431dracut_module_included "fips" && export DRACUT_FIPS_MODE=1
1743473b 1432
91190597
HH
1433do_print_cmdline()
1434{
21a20973
HH
1435 local -A _mods_to_print
1436 for i in $modules_loaded $mods_to_load; do
1437 _mods_to_print[$i]=1
1438 done
1439
1743473b
HH
1440 # source our modules.
1441 for moddir in "$dracutbasedir/modules.d"/[0-9][0-9]*; do
1442 _d_mod=${moddir##*/}; _d_mod=${_d_mod#[0-9][0-9]}
21a20973 1443 [[ ${_mods_to_print[$_d_mod]} ]] || continue
5916d31b 1444 module_cmdline "$_d_mod" "$moddir"
1743473b
HH
1445 done
1446 unset moddir
91190597
HH
1447}
1448
1449if [[ $print_cmdline ]]; then
1450 do_print_cmdline
a17d5cf4 1451 printf "\n"
1743473b
HH
1452 exit 0
1453fi
1454
dbad9f46 1455# Create some directory structure first
fd786adc 1456[[ $prefix ]] && mkdir -m 0755 -p "${initdir}${prefix}"
dbad9f46 1457
a0120420 1458[[ -h $dracutsysrootdir/lib ]] || mkdir -m 0755 -p "${initdir}${prefix}/lib"
fd786adc 1459[[ $prefix ]] && ln -sfn "${prefix#/}/lib" "$initdir/lib"
dbad9f46 1460
785a6cd2 1461if [[ $prefix ]]; then
d2a9c4a8 1462 for d in bin etc lib sbin tmp usr var $libdirs; do
b093aa2d 1463 [[ "$d" == */* ]] && continue
785a6cd2
HH
1464 ln -sfn "${prefix#/}/${d#/}" "$initdir/$d"
1465 done
1466fi
1467
1468if [[ $kernel_only != yes ]]; then
6f92423c 1469 for d in usr/bin usr/sbin bin etc lib sbin tmp usr var var/tmp $libdirs; do
fd786adc 1470 [[ -e "${initdir}${prefix}/$d" ]] && continue
d433da44
HH
1471 if [ -L "/$d" ]; then
1472 inst_symlink "/$d" "${prefix}/$d"
785a6cd2
HH
1473 else
1474 mkdir -m 0755 -p "${initdir}${prefix}/$d"
1475 fi
3b403b32 1476 done
dbad9f46 1477
8d89fc6b 1478 for d in dev proc sys sysroot root run; do
d433da44
HH
1479 if [ -L "/$d" ]; then
1480 inst_symlink "/$d"
785a6cd2
HH
1481 else
1482 mkdir -m 0755 -p "$initdir/$d"
1483 fi
33ee031c 1484 done
dbad9f46 1485
506b2192
HH
1486 ln -sfn ../run "$initdir/var/run"
1487 ln -sfn ../run/lock "$initdir/var/lock"
6f09acf8
HH
1488else
1489 for d in lib "$libdir"; do
1490 [[ -e "${initdir}${prefix}/$d" ]] && continue
1491 if [ -h "/$d" ]; then
1492 inst "/$d" "${prefix}/$d"
1493 else
1494 mkdir -m 0755 -p "${initdir}${prefix}/$d"
1495 fi
1496 done
33ee031c 1497fi
0f86847d 1498
14c47b0e
HH
1499if [[ $kernel_only != yes ]]; then
1500 mkdir -p "${initdir}/etc/cmdline.d"
4fed3ddf
HH
1501 for _d in $hookdirs; do
1502 mkdir -m 0755 -p ${initdir}/lib/dracut/hooks/$_d
1503 done
647b521f 1504 if [[ "$EUID" = "0" ]]; then
ad200fbc
HH
1505 [ -c ${initdir}/dev/null ] || mknod ${initdir}/dev/null c 1 3
1506 [ -c ${initdir}/dev/kmsg ] || mknod ${initdir}/dev/kmsg c 1 11
1507 [ -c ${initdir}/dev/console ] || mknod ${initdir}/dev/console c 5 1
83a6d6f9
HH
1508 [ -c ${initdir}/dev/random ] || mknod ${initdir}/dev/random c 1 8
1509 [ -c ${initdir}/dev/urandom ] || mknod ${initdir}/dev/urandom c 1 9
26144216 1510 fi
14c47b0e 1511fi
96b8d60a 1512
ec3c5951 1513_isize=0 #initramfs size
979c4a93 1514modules_loaded=" "
95bde758 1515# source our modules.
5d791c0e 1516for moddir in "$dracutbasedir/modules.d"/[0-9][0-9]*; do
979c4a93 1517 _d_mod=${moddir##*/}; _d_mod=${_d_mod#[0-9][0-9]}
bee08653
HH
1518 [[ "$mods_to_load" == *\ $_d_mod\ * ]] || continue
1519 if [[ $show_modules = yes ]]; then
1520 printf "%s\n" "$_d_mod"
1521 else
1522 dinfo "*** Including module: $_d_mod ***"
1523 fi
1524 if [[ $kernel_only == yes ]]; then
5916d31b 1525 module_installkernel "$_d_mod" "$moddir" || {
bee08653
HH
1526 dfatal "installkernel failed in module $_d_mod"
1527 exit 1
1528 }
1529 else
5916d31b 1530 module_install "$_d_mod" "$moddir"
bee08653 1531 if [[ $no_kernel != yes ]]; then
5916d31b 1532 module_installkernel "$_d_mod" "$moddir" || {
a6d3be9d
AW
1533 dfatal "installkernel failed in module $_d_mod"
1534 exit 1
1535 }
ec3c5951 1536 fi
66ac3cd1 1537 fi
bee08653
HH
1538 mods_to_load=${mods_to_load// $_d_mod /}
1539 modules_loaded+="$_d_mod "
1540
1541 #print the module install size
1542 if [ -n "$printsize" ]; then
1543 _isize_new=$(du -sk ${initdir}|cut -f1)
1544 _isize_delta=$((_isize_new - _isize))
1545 printf "%s\n" "$_d_mod install size: ${_isize_delta}k"
1546 _isize=$_isize_new
1547 fi
15136762 1548done
20abd914 1549unset moddir
0a35a80b
HH
1550
1551for i in $modules_loaded; do
43fed151 1552 mkdir -p $initdir/lib/dracut
b093aa2d 1553 printf "%s\n" "$i" >> $initdir/lib/dracut/modules.txt
0a35a80b
HH
1554done
1555
ea216a65 1556dinfo "*** Including modules done ***"
aabc0553 1557
0f86847d 1558## final stuff that has to happen
89d44e72 1559if [[ $no_kernel != yes ]]; then
a69e6c4e 1560 if [[ $hostonly_mode = "strict" ]]; then
a0d9ad6f 1561 cp "$DRACUT_KERNEL_MODALIASES" $initdir/lib/dracut/hostonly-kernel-modules.txt
70472946 1562 fi
aec9f902
HH
1563
1564 if [[ $drivers ]]; then
1565 hostonly='' instmods $drivers
1566 fi
1567
d53bb5c0 1568 if [[ -n "${add_drivers// }" ]]; then
aec9f902
HH
1569 hostonly='' instmods -c $add_drivers
1570 fi
cea907f6
TR
1571 if [[ $force_drivers ]]; then
1572 hostonly='' instmods -c $force_drivers
1573 rm -f $initdir/etc/cmdline.d/20-force_driver.conf
1574 for mod in $force_drivers; do
1575 echo "rd.driver.pre=$mod" >>$initdir/etc/cmdline.d/20-force_drivers.conf
1576 done
1577 fi
aec9f902
HH
1578 if [[ $filesystems ]]; then
1579 hostonly='' instmods -c $filesystems
1580 fi
1581
794b2d2c 1582 dinfo "*** Installing kernel module dependencies ***"
89d44e72 1583 dracut_kernel_post
794b2d2c 1584 dinfo "*** Installing kernel module dependencies done ***"
83bb0893
HH
1585
1586 if [[ $noimageifnotneeded == yes ]] && [[ $hostonly ]]; then
1587 if [[ ! -f "$initdir/lib/dracut/need-initqueue" ]] && \
1588 [[ -f ${initdir}/lib/modules/$kernel/modules.dep && ! -s ${initdir}/lib/modules/$kernel/modules.dep ]]; then
1589 for i in ${initdir}/etc/cmdline.d/*.conf; do
1590 # We need no initramfs image and do not generate one.
1591 [[ $i == "${initdir}/etc/cmdline.d/*.conf" ]] && exit 0
1592 done
1593 fi
1594 fi
89d44e72 1595fi
d8aeb3a7 1596
998bf6e0 1597if [[ $kernel_only != yes ]]; then
3c001899
HH
1598 (( ${#install_items[@]} > 0 )) && inst_multiple ${install_items[@]}
1599 (( ${#install_optional_items[@]} > 0 )) && inst_multiple -o ${install_optional_items[@]}
998bf6e0 1600
b093aa2d 1601 [[ $kernel_cmdline ]] && printf "%s\n" "$kernel_cmdline" >> "${initdir}/etc/cmdline.d/01-default.conf"
d20fb951 1602
694725ab 1603 for line in "${fstab_lines[@]}"; do
5f6a495b 1604 line=($line)
edbd9ca0
FV
1605
1606 if [ -z "${line[1]}" ]; then
1607 # Determine device and mount options from current system
1608 mountpoint -q "${line[0]}" || derror "${line[0]} is not a mount point!"
1609 line=($(findmnt --raw -n --target "${line[0]}" --output=source,target,fstype,options))
1610 dinfo "Line for ${line[1]}: ${line[@]}"
1611 else
1612 # Use default options
1613 [ -z "${line[3]}" ] && line[3]="defaults"
1614 fi
1615
1616 # Default options for freq and passno
5f6a495b
DY
1617 [ -z "${line[4]}" ] && line[4]="0"
1618 [ -z "${line[5]}" ] && line[5]="2"
edbd9ca0 1619
3586a7aa 1620 strstr "${line[2]}" "nfs" && line[5]="0"
5f6a495b 1621 echo "${line[@]}" >> "${initdir}/etc/fstab"
998bf6e0
HH
1622 done
1623
1624 for f in $add_fstab; do
b093aa2d 1625 cat "$f" >> "${initdir}/etc/fstab"
998bf6e0
HH
1626 done
1627
a0120420 1628 if [[ $dracutsysrootdir$systemdutildir ]]; then
2da041d6
HH
1629 if [ -d ${initdir}/$systemdutildir ]; then
1630 mkdir -p ${initdir}/etc/conf.d
1631 {
1632 printf "%s\n" "systemdutildir=\"$systemdutildir\""
1633 printf "%s\n" "systemdsystemunitdir=\"$systemdsystemunitdir\""
1634 printf "%s\n" "systemdsystemconfdir=\"$systemdsystemconfdir\""
1635 } > ${initdir}/etc/conf.d/systemd.conf
1636 fi
6c6d8057
HH
1637 fi
1638
998bf6e0
HH
1639 if [[ $DRACUT_RESOLVE_LAZY ]] && [[ $DRACUT_INSTALL ]]; then
1640 dinfo "*** Resolving executable dependencies ***"
f182cb95 1641 find "$initdir" -type f -perm /0111 -not -path '*.ko' -print0 \
a0120420 1642 | xargs -r -0 $DRACUT_INSTALL ${initdir:+-D "$initdir"} ${dracutsysrootdir:+-r "$dracutsysrootdir"} -R ${DRACUT_FIPS_MODE:+-f} --
db4d6bb4 1643 dinfo "*** Resolving executable dependencies done ***"
998bf6e0 1644 fi
8dcc4830 1645
ed9281d6
HH
1646 # Now we are done with lazy resolving, always install dependencies
1647 unset DRACUT_RESOLVE_LAZY
1648 export DRACUT_RESOLVE_DEPS=1
1649
8dcc4830
HH
1650 # libpthread workaround: pthread_cancel wants to dlopen libgcc_s.so
1651 for _dir in $libdirs; do
a0120420 1652 for _f in "$dracutsysrootdir$_dir/libpthread.so"*; do
8dcc4830
HH
1653 [[ -e "$_f" ]] || continue
1654 inst_libdir_file "libgcc_s.so*"
1655 break 2
1656 done
1657 done
998bf6e0
HH
1658fi
1659
694725ab
HH
1660for ((i=0; i < ${#include_src[@]}; i++)); do
1661 src="${include_src[$i]}"
1662 target="${include_target[$i]}"
c9364f6e 1663 if [[ $src && $target ]]; then
661f9a34 1664 if [[ -f $src ]]; then
c9364f6e 1665 inst $src $target
7a3d6619 1666 elif [[ -d $src ]]; then
3b403b32 1667 ddebug "Including directory: $src"
c9364f6e 1668 destdir="${initdir}/${target}"
332ecaa9 1669 mkdir -p "$destdir"
dbad9f46 1670 # check for preexisting symlinks, so we can cope with the
fd786adc 1671 # symlinks to $prefix
c9364f6e
EV
1672 # Objectname is a file or a directory
1673 for objectname in "$src"/*; do
1674 [[ -e "$objectname" || -h "$objectname" ]] || continue
1675 if [[ -d "$objectname" ]]; then
1676 # objectname is a directory, let's compute the final directory name
1677 object_destdir=${destdir}/${objectname#$src/}
1678 if ! [[ -e "$object_destdir" ]]; then
1679 mkdir -m 0755 -p "$object_destdir"
1680 chmod --reference="$objectname" "$object_destdir"
dbad9f46 1681 fi
a0120420 1682 $DRACUT_CP -t "$object_destdir" "$dracutsysrootdir$objectname"/*
dbad9f46 1683 else
a0120420 1684 $DRACUT_CP -t "$destdir" "$dracutsysrootdir$objectname"
3b403b32 1685 fi
dbad9f46 1686 done
7a3d6619
RM
1687 elif [[ -e $src ]]; then
1688 derror "$src is neither a directory nor a regular file"
1689 else
1690 derror "$src doesn't exist"
661f9a34 1691 fi
4fea3ea6 1692 fi
661f9a34 1693done
88ffd2df 1694
14c47b0e 1695if [[ $kernel_only != yes ]]; then
1254925f 1696 # make sure that library links are correct and up to date
a0120420
BZ
1697 for f in $dracutsysrootdir/etc/ld.so.conf $dracutsysrootdir/etc/ld.so.conf.d/*; do
1698 [[ -f $f ]] && inst_simple "${f#$dracutsysrootdir}"
1254925f 1699 done
a0120420 1700 if ! $DRACUT_LDCONFIG -r "$initdir" -f /etc/ld.so.conf; then
647b521f 1701 if [[ $EUID = 0 ]]; then
1254925f
HH
1702 derror "ldconfig exited ungracefully"
1703 else
1704 derror "ldconfig might need uid=0 (root) for chroot()"
1705 fi
432196ae
1706 fi
1707fi
fdc421db 1708
404815ea
HH
1709if [[ $do_hardlink = yes ]] && command -v hardlink >/dev/null; then
1710 dinfo "*** Hardlinking files ***"
1711 hardlink "$initdir" 2>&1
1712 dinfo "*** Hardlinking files done ***"
1713fi
1714
3b403b32 1715# strip binaries
98adb06e 1716if [[ $do_strip = yes ]] ; then
8b6d136e
DM
1717 # Prefer strip from elfutils for package size
1718 declare strip_cmd=$(command -v eu-strip)
1719 test -z "$strip_cmd" && strip_cmd="strip"
1720
1721 for p in $strip_cmd xargs find; do
cc02093d 1722 if ! type -P $p >/dev/null; then
fefd3f66 1723 dinfo "Could not find '$p'. Not stripping the initramfs."
cc02093d
HH
1724 do_strip=no
1725 fi
31f7db66
HH
1726 done
1727fi
1728
f6e777ec
HH
1729# cleanup empty ldconfig_paths directories
1730for d in $(ldconfig_paths); do
1731 rmdir -p --ignore-fail-on-non-empty "$initdir/$d" >/dev/null 2>&1
1732done
1733
5f2c30d9
KRW
1734if [[ $early_microcode = yes ]]; then
1735 dinfo "*** Generating early-microcode cpio image ***"
1736 ucode_dir=(amd-ucode intel-ucode)
1737 ucode_dest=(AuthenticAMD.bin GenuineIntel.bin)
b5b608e4 1738 _dest_dir="$early_cpio_dir/d/kernel/x86/microcode"
5f2c30d9
KRW
1739 _dest_idx="0 1"
1740 mkdir -p $_dest_dir
1741 if [[ $hostonly ]]; then
1742 [[ $(get_cpu_vendor) == "AMD" ]] && _dest_idx="0"
1743 [[ $(get_cpu_vendor) == "Intel" ]] && _dest_idx="1"
1744 fi
1745 for idx in $_dest_idx; do
1746 _fw=${ucode_dir[$idx]}
1747 for _fwdir in $fw_dir; do
1748 if [[ -d $_fwdir && -d $_fwdir/$_fw ]]; then
1749 _src="*"
f18d069d 1750 dinfo "*** Constructing ${ucode_dest[$idx]} ***"
5f2c30d9
KRW
1751 if [[ $hostonly ]]; then
1752 _src=$(get_ucode_file)
b44156c6 1753 [[ $_src ]] || break
feebf171 1754 [[ -r $_fwdir/$_fw/$_src ]] || _src="${_src}.early"
efba549a 1755 [[ -r $_fwdir/$_fw/$_src ]] || break
5f2c30d9 1756 fi
efba549a 1757
583fb231 1758 for i in $_fwdir/$_fw/$_src; do
efba549a 1759 [ -e "$i" ] && break
583fb231
HH
1760 break 2
1761 done
c44d2252
HH
1762 for i in $_fwdir/$_fw/$_src; do
1763 [[ -e "$i" ]] || continue
1764 # skip gpg files
1765 str_ends "$i" ".asc" && continue
1766 cat "$i" >> $_dest_dir/${ucode_dest[$idx]}
1767 done
d8b04dc1 1768 create_early_cpio="yes"
5f2c30d9
KRW
1769 fi
1770 done
d613d88d
JW
1771 if [[ ! -e "$_dest_dir/${ucode_dest[$idx]}" ]]; then
1772 cd "$early_cpio_dir/d"
1773 for _ucodedir in "${early_microcode_image_dir[@]}"; do
1774 for _ucodename in "${early_microcode_image_name[@]}"; do
1775 [[ -e "$_ucodedir/$_ucodename" ]] && \
1776 cpio --extract --file "$_ucodedir/$_ucodename" --quiet \
1777 "kernel/x86/microcode/${ucode_dest[$idx]}"
1778 if [[ -e "$_dest_dir/${ucode_dest[$idx]}" ]]; then
1779 dinfo "*** Using microcode found in '$_ucodedir/$_ucodename' ***"
1780 create_early_cpio="yes"
1781 break 2
1782 fi
1783 done
1784 done
1785 fi
5f2c30d9 1786 done
5f2c30d9 1787fi
bbaa0d59 1788
f3b14c2b
TR
1789if [[ $acpi_override = yes ]] && [[ -d $acpi_table_dir ]]; then
1790 dinfo "*** Packaging ACPI tables to override BIOS provided ones ***"
1791 _dest_dir="$early_cpio_dir/d/kernel/firmware/acpi"
1792 mkdir -p $_dest_dir
1793 for table in $acpi_table_dir/*.aml; do
1794 dinfo " Adding ACPI table: $table"
7e51a94f 1795 $DRACUT_CP $table $_dest_dir
f3b14c2b
TR
1796 create_early_cpio="yes"
1797 done
1798fi
1799
659dc319
HB
1800dinfo "*** Store current command line parameters ***"
1801if ! ( echo $PARMS_TO_STORE > $initdir/lib/dracut/build-parameter.txt ); then
1802 dfatal "Could not store the current command line parameters"
1803 exit 1
1804fi
1805
76dd870b 1806if [[ $hostonly_cmdline == "yes" ]] ; then
496e3d96 1807 unset _stored_cmdline
fe273e39
HR
1808 if [ -d $initdir/etc/cmdline.d ];then
1809 dinfo "Stored kernel commandline:"
1810 for conf in $initdir/etc/cmdline.d/*.conf ; do
496e3d96 1811 [ -e "$conf" ] || continue
fe273e39 1812 dinfo "$(< $conf)"
496e3d96 1813 _stored_cmdline=1
fe273e39 1814 done
496e3d96
HH
1815 fi
1816 if ! [[ $_stored_cmdline ]]; then
62c00a88 1817 dinfo "No dracut internal kernel commandline stored in the initramfs"
fe273e39
HR
1818 fi
1819fi
62c00a88 1820
095e1f37 1821if dracut_module_included "squash"; then
6a74c03b 1822 dinfo "*** Install squash loader ***"
095e1f37
KS
1823 if ! check_kernel_config CONFIG_SQUASHFS; then
1824 dfatal "CONFIG_SQUASHFS have to be enabled for dracut squash module to work"
1825 exit 1
1826 fi
1827 if ! check_kernel_config CONFIG_OVERLAY_FS; then
1828 dfatal "CONFIG_OVERLAY_FS have to be enabled for dracut squash module to work"
1829 exit 1
1830 fi
1831 if ! check_kernel_config CONFIG_DEVTMPFS; then
1832 dfatal "CONFIG_DEVTMPFS have to be enabled for dracut squash module to work"
1833 exit 1
1834 fi
1835
6a74c03b 1836 readonly squash_dir="$initdir/squash/root"
095e1f37
KS
1837 readonly squash_img=$initdir/squash/root.img
1838
1839 # Currently only move "usr" "etc" to squashdir
1840 readonly squash_candidate=( "usr" "etc" )
1841
1842 mkdir -m 0755 -p $squash_dir
1843 for folder in "${squash_candidate[@]}"; do
1844 mv $initdir/$folder $squash_dir/$folder
1845 done
1846
095e1f37
KS
1847 # Move some files out side of the squash image, including:
1848 # - Files required to boot and mount the squashfs image
f18d069d 1849 # - Files need to be accessible without mounting the squash image
095e1f37
KS
1850 required_in_root() {
1851 local file=$1
1852 local _sqsh_file=$squash_dir/$file
1853 local _init_file=$initdir/$file
1854
1855 if [[ -e $_init_file ]]; then
1856 return
1857 fi
1858
1859 if [[ ! -e $_sqsh_file ]] && [[ ! -L $_sqsh_file ]]; then
1860 derror "$file is required to boot a squashed initramfs but it's not installed!"
1861 return
1862 fi
1863
1864 if [[ ! -d $(dirname $_init_file) ]]; then
1865 required_in_root $(dirname $file)
1866 fi
1867
f6bbd024
KS
1868 if [[ -L $_sqsh_file ]]; then
1869 cp --preserve=all -P $_sqsh_file $_init_file
1870 _sqsh_file=$(realpath $_sqsh_file 2>/dev/null)
1871 if [[ -e $_sqsh_file ]] && [[ "$_sqsh_file" == "$squash_dir"* ]]; then
1872 # Relative symlink
1873 required_in_root ${_sqsh_file#$squash_dir/}
1874 return
1875 fi
1876 if [[ -e $squash_dir$_sqsh_file ]]; then
1877 # Absolute symlink
1878 required_in_root ${_sqsh_file#/}
1879 return
1880 fi
1881 required_in_root ${module_spec#$squash_dir/}
095e1f37 1882 else
f6bbd024
KS
1883 if [[ -d $_sqsh_file ]]; then
1884 mkdir $_init_file
1885 else
1886 mv $_sqsh_file $_init_file
1887 fi
095e1f37
KS
1888 fi
1889 }
1890
1891 required_in_root etc/initrd-release
1892
1893 for module_spec in $squash_dir/usr/lib/modules/*/modules.*;
1894 do
1895 required_in_root ${module_spec#$squash_dir/}
1896 done
1897
1898 for dracut_spec in $squash_dir/usr/lib/dracut/*;
1899 do
1900 required_in_root ${dracut_spec#$squash_dir/}
1901 done
1902
1903 mv $initdir/init $initdir/init.stock
095e1f37 1904 ln -s squash/init.sh $initdir/init
095e1f37 1905
19e57585
KS
1906 # Reinstall required files for the squash image setup script.
1907 # We have moved them inside the squashed image, but they need to be
1908 # accessible before mounting the image.
1909 inst_multiple "echo" "sh" "mount" "modprobe" "mkdir"
1910 hostonly="" instmods "loop" "squashfs" "overlay"
1911
1912 # Only keep systemctl outsite if we need switch root
1913 if [[ ! -f "$initdir/lib/dracut/no-switch-root" ]]; then
1914 inst "systemctl"
1915 fi
1916
1917 for folder in "${squash_candidate[@]}"; do
1918 # Remove duplicated files in squashfs image, save some more space
1919 [[ ! -d $initdir/$folder/ ]] && continue
1920 for file in $(find $initdir/$folder/ -not -type d);
1921 do
1922 if [[ -e $squash_dir${file#$initdir} ]]; then
1923 mv $squash_dir${file#$initdir} $file
1924 fi
1925 done
1926 done
6a74c03b 1927fi
19e57585 1928
6a74c03b
KS
1929if [[ $do_strip = yes ]] && ! [[ $DRACUT_FIPS_MODE ]]; then
1930 dinfo "*** Stripping files ***"
1931 find "$initdir" -type f \
1932 -executable -not -path '*/lib/modules/*.ko' -print0 \
1933 | xargs -r -0 $strip_cmd -g -p 2>/dev/null
1934
1935 # strip kernel modules, but do not touch signed modules
1936 find "$initdir" -type f -path '*/lib/modules/*.ko' -print0 \
1937 | while read -r -d $'\0' f || [ -n "$f" ]; do
1938 SIG=$(tail -c 28 "$f" | tr -d '\000')
1939 [[ $SIG == '~Module signature appended~' ]] || { printf "%s\000" "$f"; }
1940 done | xargs -r -0 $strip_cmd -g -p
1941 dinfo "*** Stripping files done ***"
1942fi
1943
1944if dracut_module_included "squash"; then
1945 dinfo "*** Squashing the files inside the initramfs ***"
89bc1aa3 1946 mksquashfs $squash_dir $squash_img -no-xattrs -no-exports -noappend -always-use-fragments -comp xz -Xdict-size 100% -no-progress 1> /dev/null
095e1f37
KS
1947
1948 if [[ $? != 0 ]]; then
1949 dfatal "dracut: Failed making squash image"
1950 exit 1
1951 fi
6a74c03b
KS
1952
1953 rm -rf $squash_dir
1954 dinfo "*** Squashing the files inside the initramfs done ***"
095e1f37
KS
1955fi
1956
6a74c03b
KS
1957dinfo "*** Creating image file '$outfile' ***"
1958
636d2d46 1959if [[ $uefi = yes ]]; then
62c00a88
HH
1960 readonly uefi_outdir="$DRACUT_TMPDIR/uefi"
1961 mkdir "$uefi_outdir"
636d2d46 1962fi
c8a9a6b4 1963
80626ded
HH
1964if [[ $DRACUT_REPRODUCIBLE ]]; then
1965 find "$initdir" -newer "$dracutbasedir/dracut-functions.sh" -print0 \
1966 | xargs -r -0 touch -h -m -c -r "$dracutbasedir/dracut-functions.sh"
1967
10f8df1b
HH
1968 if [[ "$(cpio --help)" == *--reproducible* ]]; then
1969 CPIO_REPRODUCIBLE=1
1970 else
1971 dinfo "cpio does not support '--reproducible'. Resulting image will not be reproducible."
1972 fi
80626ded
HH
1973fi
1974
647b521f 1975[[ "$EUID" != 0 ]] && cpio_owner_root="-R 0:0"
c8a9a6b4 1976
b5b608e4 1977if [[ $create_early_cpio = yes ]]; then
b9909e33 1978 echo 1 > "$early_cpio_dir/d/early_cpio"
80626ded
HH
1979
1980 if [[ $DRACUT_REPRODUCIBLE ]]; then
1981 find "$early_cpio_dir/d" -newer "$dracutbasedir/dracut-functions.sh" -print0 \
1982 | xargs -r -0 touch -h -m -c -r "$dracutbasedir/dracut-functions.sh"
1983 fi
1984
5f2c30d9 1985 # The microcode blob is _before_ the initramfs blob, not after
62c00a88 1986 if ! (
0db98910 1987 umask 077; cd "$early_cpio_dir/d"
62c00a88
HH
1988 find . -print0 | sort -z \
1989 | cpio ${CPIO_REPRODUCIBLE:+--reproducible} --null $cpio_owner_root -H newc -o --quiet > "${DRACUT_TMPDIR}/initramfs.img"
1990 ); then
1991 dfatal "dracut: creation of $outfile failed"
1992 exit 1
1993 fi
5f2c30d9 1994fi
80626ded
HH
1995
1996if ! (
1997 umask 077; cd "$initdir"
1998 find . -print0 | sort -z \
1999 | cpio ${CPIO_REPRODUCIBLE:+--reproducible} --null $cpio_owner_root -H newc -o --quiet \
62c00a88 2000 | $compress >> "${DRACUT_TMPDIR}/initramfs.img"
80626ded 2001 ); then
dc4c1ee3 2002 dfatal "dracut: creation of $outfile failed"
734a0d9e 2003 exit 1
3b403b32 2004fi
2cc5e92e 2005
bd93e928 2006if (( maxloglvl >= 5 )) && (( verbosity_mod_l >= 0 )); then
dadd2b69 2007 if [[ $allowlocal ]]; then
62c00a88 2008 "$dracutbasedir/lsinitrd.sh" "${DRACUT_TMPDIR}/initramfs.img"| ddebug
dadd2b69 2009 else
62c00a88 2010 lsinitrd "${DRACUT_TMPDIR}/initramfs.img"| ddebug
dadd2b69 2011 fi
bbaa0d59 2012fi
1faecdc1 2013
60928f36
HH
2014umask 077
2015
636d2d46
HH
2016if [[ $uefi = yes ]]; then
2017 if [[ $kernel_cmdline ]]; then
2018 echo -n "$kernel_cmdline" > "$uefi_outdir/cmdline.txt"
2019 elif [[ $hostonly_cmdline = yes ]] && [ -d $initdir/etc/cmdline.d ];then
2020 for conf in $initdir/etc/cmdline.d/*.conf ; do
2021 [ -e "$conf" ] || continue
2022 printf "%s " "$(< $conf)" >> "$uefi_outdir/cmdline.txt"
2023 done
2024 else
2025 do_print_cmdline > "$uefi_outdir/cmdline.txt"
2026 fi
2027 echo -ne "\x00" >> "$uefi_outdir/cmdline.txt"
2028
2029 dinfo "Using UEFI kernel cmdline:"
0a010864 2030 dinfo $(tr -d '\000' < "$uefi_outdir/cmdline.txt")
636d2d46 2031
a0120420
BZ
2032 [[ -s $dracutsysrootdir/usr/lib/os-release ]] && uefi_osrelease="$dracutsysrootdir/usr/lib/os-release"
2033 [[ -s $dracutsysrootdir/etc/os-release ]] && uefi_osrelease="$dracutsysrootdir/etc/os-release"
4237aeb0
DT
2034 [[ -s "${dracutsysrootdir}${uefi_splash_image}" ]] && \
2035 uefi_splash_image="${dracutsysroot}${uefi_splash_image}" || unset uefi_splash_image
636d2d46 2036
62c00a88
HH
2037 if objcopy \
2038 ${uefi_osrelease:+--add-section .osrel=$uefi_osrelease --change-section-vma .osrel=0x20000} \
2039 --add-section .cmdline="${uefi_outdir}/cmdline.txt" --change-section-vma .cmdline=0x30000 \
4237aeb0
DT
2040 ${uefi_splash_image:+--add-section .splash="$uefi_splash_image" --change-section-vma .splash=0x40000} \
2041 --add-section .linux="$kernel_image" --change-section-vma .linux=0x2000000 \
62c00a88 2042 --add-section .initrd="${DRACUT_TMPDIR}/initramfs.img" --change-section-vma .initrd=0x3000000 \
5a962b59
MR
2043 "$uefi_stub" "${uefi_outdir}/linux.efi"; then
2044 if [[ -n "${uefi_secureboot_key}" && -n "${uefi_secureboot_cert}" ]]; then \
2045 if sbsign \
2046 --key "${uefi_secureboot_key}" \
2047 --cert "${uefi_secureboot_cert}" \
2048 --output "$outfile" "${uefi_outdir}/linux.efi"; then
2049 dinfo "*** Creating signed UEFI image file '$outfile' done ***"
2050 else
2051 dfatal "*** Creating signed UEFI image file '$outfile' failed ***"
2052 exit 1
2053 fi
2054 else
2055 if cp --reflink=auto "${uefi_outdir}/linux.efi" "$outfile"; then
2056 dinfo "*** Creating UEFI image file '$outfile' done ***"
2057 fi
2058 fi
62c00a88
HH
2059 else
2060 rm -f -- "$outfile"
2061 dfatal "*** Creating UEFI image file '$outfile' failed ***"
2062 exit 1
2063 fi
2064else
60928f36 2065 if cp --reflink=auto "${DRACUT_TMPDIR}/initramfs.img" "$outfile"; then
62c00a88
HH
2066 dinfo "*** Creating initramfs image file '$outfile' done ***"
2067 else
2068 rm -f -- "$outfile"
2069 dfatal "dracut: creation of $outfile failed"
2070 exit 1
2071 fi
636d2d46
HH
2072fi
2073
60928f36 2074command -v restorecon &>/dev/null && restorecon -- "$outfile"
62c00a88 2075
740e41b8
CW
2076# We sync/fsfreeze only if we're operating on a live booted system.
2077# It's possible for e.g. `kernel` to be installed as an RPM BuildRequires or equivalent,
2078# and there's no reason to sync, and *definitely* no reason to fsfreeze.
2079# Another case where this happens is rpm-ostree, which performs its own sync/fsfreeze
2080# globally. See e.g. https://github.com/ostreedev/ostree/commit/8642ef5ab3fec3ac8eb8f193054852f83a8bc4d0
a0120420 2081if test -d $dracutsysrootdir/run/systemd/system; then
740e41b8
CW
2082 if ! sync "$outfile" 2> /dev/null; then
2083 dinfo "dracut: sync operation on newly created initramfs $outfile failed"
2084 exit 1
2085 fi
7bc681fd 2086
740e41b8
CW
2087 # use fsfreeze only if we're not writing to /
2088 if [[ "$(stat -c %m -- "$outfile")" != "/" && "$(stat -f -c %T -- "$outfile")" != "msdos" ]]; then
2089 if ! $(fsfreeze -f $(dirname "$outfile") 2>/dev/null && fsfreeze -u $(dirname "$outfile") 2>/dev/null); then
2090 dinfo "dracut: warning: could not fsfreeze $(dirname "$outfile")"
2091 fi
de576db3 2092 fi
e316ae0e
AK
2093fi
2094
3da58569 2095exit 0